=== modified file 'Makefile.am'
--- Makefile.am	2013-01-07 15:57:20 +0000
+++ Makefile.am	2012-06-12 03:22:19 +0000
@@ -1,6 +1,6 @@
 # Copyright (c) 2011, Linaro Limited
 # All rights reserved.
-#
+# 
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
 #     * Redistributions of source code must retain the above copyright
@@ -11,7 +11,7 @@
 #     * Neither the name of the Linaro nor the
 #       names of its contributors may be used to endorse or promote products
 #       derived from this software without specific prior written permission.
-#
+# 
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
@@ -21,7 +21,7 @@
 # LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 #
 
 # Top level Makefile for cortex-strings
@@ -29,185 +29,90 @@
 # Used to record the compiler version in the executables
 COMPILER = $(shell $(CC) --version 2>&1 | head -n1)
 
+if WITH_NEON
+# Pull in the NEON specific files
+neon_sources = \
+	src/linaro-a9/memcpy-hybrid.S
+neon_bionic_sources = \
+	reference/bionic/memcpy.S
+neon_cppflags = -mfpu=neon
+neon_dirs = neon
+else
+alternate_sources = \
+	src/linaro-a9/memcpy.S
+endif
+
 # The main library
 lib_LTLIBRARIES = \
 	libcortex-strings.la
 
-## Test suite
+# Test suite
 check_PROGRAMS = \
 	tests/test-memchr \
-	tests/test-memcmp \
 	tests/test-memcpy \
-	tests/test-memmove \
 	tests/test-memset \
 	tests/test-strchr \
 	tests/test-strcmp \
 	tests/test-strcpy \
-	tests/test-strlen \
-	tests/test-strncmp \
-	tests/test-strnlen
-
-# Options for the tests
-tests_cflags = -I$(srcdir)/tests $(AM_CFLAGS)
-tests_ldadd = libcortex-strings.la
-tests_test_memchr_LDADD = $(tests_ldadd)
-tests_test_memchr_CFLAGS = $(tests_cflags)
-tests_test_memcmp_LDADD = $(tests_ldadd)
-tests_test_memcmp_CFLAGS = $(tests_cflags)
-tests_test_memcpy_LDADD = $(tests_ldadd)
-tests_test_memcpy_CFLAGS = $(tests_cflags)
-tests_test_memmove_LDADD = $(tests_ldadd)
-tests_test_memmove_CFLAGS = $(tests_cflags)
-tests_test_memset_LDADD = $(tests_ldadd)
-tests_test_memset_CFLAGS = $(tests_cflags)
-tests_test_strchr_LDADD = $(tests_ldadd)
-tests_test_strchr_CFLAGS = $(tests_cflags)
-tests_test_strcmp_LDADD = $(tests_ldadd)
-tests_test_strcmp_CFLAGS = $(tests_cflags)
-tests_test_strcpy_LDADD = $(tests_ldadd)
-tests_test_strcpy_CFLAGS = $(tests_cflags)
-tests_test_strlen_LDADD = $(tests_ldadd)
-tests_test_strlen_CFLAGS = $(tests_cflags)
-tests_test_strncmp_LDADD = $(tests_ldadd)
-tests_test_strncmp_CFLAGS = $(tests_cflags)
-
-TESTS = $(check_PROGRAMS)
-
-## Benchmarks
+	tests/test-strlen
+
+# Benchmarks and example programs
 noinst_PROGRAMS = \
 	dhry \
 	dhry-native \
 	try-none \
 	try-this \
-	try-plain \
-	try-newlib-c \
+	try-bionic \
 	try-bionic-c \
-	try-glibc-c
-
-# Good 'ol Dhrystone
-dhry_SOURCES = \
-	benchmarks/dhry/dhry_1.c \
-	benchmarks/dhry/dhry_2.c \
-	benchmarks/dhry/dhry.h
-
-dhry_CFLAGS = -Dcompiler="\"$(COMPILER)\"" -Doptions="\"$(CFLAGS)\""
-dhry_LDADD = libcortex-strings.la
-
-dhry_native_SOURCES = $(dhry_SOURCES)
-dhry_native_CFLAGS = $(dhry_CFLAGS)
-
-# Benchmark harness
-noinst_LIBRARIES = \
-	libmulti.a \
-	libbionic-c.a \
-	libglibc-c.a \
-	libnewlib-c.a \
-	libplain.a
-
-libmulti_a_SOURCES = \
-	benchmarks/multi/harness.c
-
-libmulti_a_CFLAGS = -DVERSION=\"$(VERSION)\" $(AM_CFLAGS)
-
-## Other architecture independant implementaions
-libbionic_c_a_SOURCES = \
-	reference/bionic-c/bcopy.c \
-	reference/bionic-c/memchr.c \
-	reference/bionic-c/memcmp.c \
-	reference/bionic-c/memcpy.c \
-	reference/bionic-c/memset.c \
-	reference/bionic-c/strchr.c \
-	reference/bionic-c/strcmp.c \
-	reference/bionic-c/strcpy.c \
-	reference/bionic-c/strlen.c
-
-libglibc_c_a_SOURCES = \
-	reference/glibc-c/memchr.c \
-	reference/glibc-c/memcmp.c \
-	reference/glibc-c/memcpy.c \
-	reference/glibc-c/memset.c \
-	reference/glibc-c/strchr.c \
-	reference/glibc-c/strcmp.c \
-	reference/glibc-c/strcpy.c \
-	reference/glibc-c/strlen.c \
-	reference/glibc-c/wordcopy.c \
-	reference/glibc-c/bp-checks.h \
-	reference/glibc-c/memcopy.h \
-	reference/glibc-c/pagecopy.h
-
-libnewlib_c_a_SOURCES = \
-	reference/newlib-c/memchr.c \
-	reference/newlib-c/memcmp.c \
-	reference/newlib-c/memcpy.c \
-	reference/newlib-c/memset.c \
-	reference/newlib-c/strchr.c \
-	reference/newlib-c/strcmp.c \
-	reference/newlib-c/strcpy.c \
-	reference/newlib-c/strlen.c \
-	reference/newlib-c/shim.h
-
-libplain_a_SOURCES = \
-	reference/plain/memset.c \
-	reference/plain/memcpy.c \
-	reference/plain/strcmp.c \
-	reference/plain/strcpy.c
-
-try_none_SOURCES =
-try_none_LDADD = libmulti.a -lrt
-try_this_SOURCES =
-try_this_LDADD = libmulti.a libcortex-strings.la -lrt
-try_bionic_c_SOURCES =
-try_bionic_c_LDADD = libmulti.a libbionic-c.a -lrt
-try_glibc_c_SOURCES =
-try_glibc_c_LDADD = libmulti.a libglibc-c.a -lrt
-try_newlib_c_SOURCES =
-try_newlib_c_LDADD = libmulti.a libnewlib-c.a -lrt
-try_plain_SOURCES =
-try_plain_LDADD = libmulti.a libplain.a -lrt
-
-# Architecture specific
-
-if HOST_AARCH32
-
-if WITH_NEON
-# Pull in the NEON specific files
-neon_sources = \
-	src/linaro-a9/memcpy-hybrid.S
-neon_bionic_sources = \
-	reference/bionic/memcpy.S
-neon_cppflags = -mfpu=neon
-neon_dirs = neon
-else
-alternate_sources = \
-	src/linaro-a9/memcpy.S
-endif
-
-# Benchmarks and example programs
-noinst_PROGRAMS += \
-	try-bionic \
 	try-csl \
 	try-glibc \
+	try-glibc-c \
 	try-newlib \
-	try-newlib-xscale
+	try-newlib-c \
+	try-newlib-xscale \
+	try-plain
 
 # Libraries used in the benchmarks and examples
-noinst_LIBRARIES += \
+noinst_LIBRARIES = \
 	libbionic.a \
+	libbionic-c.a \
 	libcsl.a \
 	libglibc.a \
+	libglibc-c.a \
 	libnewlib.a \
-	libnewlib-xscale.a
+	libnewlib-c.a \
+	libnewlib-xscale.a \
+	libplain.a \
+	libmulti.a
 
 # Main library
 libcortex_strings_la_SOURCES = \
 	$(neon_sources) \
 	$(alternate_sources) \
 	src/thumb-2/strcpy.c \
-	src/linaro-a9/memchr.S \
-	src/linaro-a9/strchr.S \
-	src/linaro-a9/strlen.S \
+	src/linaro-a9/memchr.s \
+	src/linaro-a9/strchr.s \
+	src/linaro-a9/strlen.s \
 	src/linaro-a9/memset.S
 
+libcortex_strings_la_LDFLAGS = -version-info 1:0:0
+
+# Options for the tests
+tests_cflags = -I$(srcdir)/tests $(AM_CFLAGS)
+tests_ldadd = libcortex-strings.la
+tests_test_memcpy_LDADD = $(tests_ldadd)
+tests_test_memcpy_CFLAGS = $(tests_cflags)
+tests_test_memset_LDADD = $(tests_ldadd)
+tests_test_memset_CFLAGS = $(tests_cflags)
+tests_test_strcmp_LDADD = $(tests_ldadd)
+tests_test_strcmp_CFLAGS = $(tests_cflags)
+tests_test_strcpy_LDADD = $(tests_ldadd)
+tests_test_strcpy_CFLAGS = $(tests_cflags)
+tests_test_strlen_LDADD = $(tests_ldadd)
+tests_test_strlen_CFLAGS = $(tests_cflags)
+
+TESTS = $(check_PROGRAMS)
+
 # Libraries containing the difference reference versions
 libbionic_a_SOURCES = \
 	$(neon_bionic_sources) \
@@ -219,6 +124,16 @@
 
 libbionic_a_CFLAGS = -Wa,-mimplicit-it=thumb
 
+libbionic_c_a_SOURCES = \
+	reference/bionic-c/memchr.c \
+	reference/bionic-c/memcmp.c \
+	reference/bionic-c/memcpy.c \
+	reference/bionic-c/memset.c \
+	reference/bionic-c/strchr.c \
+	reference/bionic-c/strcmp.c \
+	reference/bionic-c/strcpy.c \
+	reference/bionic-c/strlen.c
+
 libcsl_a_SOURCES = \
 	reference/csl/memcpy.c \
 	reference/csl/memset.c \
@@ -229,6 +144,17 @@
 	reference/glibc/memset.S \
 	reference/glibc/strlen.S
 
+libglibc_c_a_SOURCES = \
+	reference/glibc-c/memchr.c \
+	reference/glibc-c/memcmp.c \
+	reference/glibc-c/memcpy.c \
+	reference/glibc-c/memset.c \
+	reference/glibc-c/strchr.c \
+	reference/glibc-c/strcmp.c \
+	reference/glibc-c/strcpy.c \
+	reference/glibc-c/strlen.c \
+	reference/glibc-c/wordcopy.c
+
 libnewlib_a_SOURCES = \
 	reference/newlib/memcpy.S \
 	reference/newlib/strcmp.S \
@@ -237,6 +163,16 @@
 	reference/newlib/arm_asm.h \
 	reference/newlib/shim.h
 
+libnewlib_c_a_SOURCES = \
+	reference/newlib-c/memchr.c \
+	reference/newlib-c/memcmp.c \
+	reference/newlib-c/memcpy.c \
+	reference/newlib-c/memset.c \
+	reference/newlib-c/strchr.c \
+	reference/newlib-c/strcmp.c \
+	reference/newlib-c/strcpy.c \
+	reference/newlib-c/strlen.c
+
 libnewlib_xscale_a_SOURCES = \
 	reference/newlib-xscale/memchr.c \
 	reference/newlib-xscale/memcpy.c \
@@ -247,60 +183,62 @@
 	reference/newlib-xscale/strlen.c \
 	reference/newlib-xscale/xscale.h
 
+libplain_a_SOURCES = \
+	reference/plain/memset.c \
+	reference/plain/memcpy.c \
+	reference/plain/strcmp.c \
+	reference/plain/strcpy.c
+
+libmulti_a_SOURCES = \
+	benchmarks/multi/harness.c
+
+libmulti_a_CFLAGS = -DVERSION=\"$(VERSION)\" $(AM_CFLAGS)
+
 # Flags for the benchmark helpers
+try_none_SOURCES =
+try_none_LDADD = libmulti.a -lrt
+try_this_SOURCES =
+try_this_LDADD = libmulti.a libcortex-strings.la -lrt
 try_bionic_SOURCES =
 try_bionic_LDADD = libmulti.a libbionic.a -lrt
+try_bionic_c_SOURCES =
+try_bionic_c_LDADD = libmulti.a libbionic-c.a -lrt
 try_csl_SOURCES =
 try_csl_LDADD = libmulti.a libcsl.a -lrt
 try_glibc_SOURCES =
 try_glibc_LDADD = libmulti.a libglibc.a -lrt
+try_glibc_c_SOURCES =
+try_glibc_c_LDADD = libmulti.a libglibc-c.a -lrt
 try_newlib_SOURCES =
 try_newlib_LDADD = libmulti.a libnewlib.a -lrt
+try_newlib_c_SOURCES =
+try_newlib_c_LDADD = libmulti.a libnewlib-c.a -lrt
 try_newlib_xscale_SOURCES =
 try_newlib_xscale_LDADD = libmulti.a libnewlib-xscale.a -lrt
+try_plain_SOURCES =
+try_plain_LDADD = libmulti.a libplain.a -lrt
+
+# Good 'ol Dhrystone
+dhry_SOURCES = \
+	benchmarks/dhry/dhry_1.c \
+	benchmarks/dhry/dhry_2.c \
+	benchmarks/dhry/dhry.h
+
+dhry_CFLAGS = -Dcompiler="\"$(COMPILER)\"" -Doptions="\"$(CFLAGS)\""
+dhry_LDADD = libcortex-strings.la
+
+dhry_native_SOURCES = $(dhry_SOURCES)
+dhry_native_CFLAGS = $(dhry_CFLAGS)
 
 AM_CPPFLAGS = $(neon_cppflags)
-
-endif
-
-# aarch64 specific
-if HOST_AARCH64
-
-libcortex_strings_la_SOURCES = \
-	src/aarch64/memcmp.S \
-	src/aarch64/memcpy.S \
-	src/aarch64/memmove.S \
-	src/aarch64/memset.S \
-	src/aarch64/strcmp.S \
-	src/aarch64/strlen.S \
-	src/aarch64/strncmp.S \
-	src/aarch64/strnlen.S
-
-endif
-
-libcortex_strings_la_LDFLAGS = -version-info 1:0:0
-
-AM_CFLAGS = \
-	-std=gnu99 -Wall \
+AM_CFLAGS = -std=gnu99 -Wall \
 	-fno-builtin -fno-stack-protector -U_FORTIFY_SOURCE \
-	$(AM_CPPFLAGS)
-
-if WITH_SUBMACHINE
-AM_CFLAGS += \
-	-mtune=$(submachine)
-endif
+	-mtune=$(submachine) $(AM_CPPFLAGS)
 
 EXTRA_DIST = \
 	tests/hp-timing.h \
 	tests/test-string.h \
 	tests/test-skeleton.c \
-	scripts/add-license.sh \
-	scripts/bench.py \
-	scripts/fixup.py \
-	scripts/libplot.py \
-	scripts/plot-align.py \
-	scripts/plot.py \
-	scripts/plot-sizes.py \
-	scripts/plot-top.py \
-	scripts/trim.sh \
 	autogen.sh
+
+AM_DISTCHECK_CONFIGURE_FLAGS = --host=arm-linux-gnueabi

=== added file 'NOTES'
--- NOTES	1970-01-01 00:00:00 +0000
+++ NOTES	2011-09-15 14:42:16 +0000
@@ -0,0 +1,10 @@
+= Random notes =
+As at 2011-09-15, the routines are:
+ * From Linaro:
+  * memchr
+  * memcpy
+  * memset
+  * strchr
+  * strlen
+ * From ARM:
+  * strcpy

=== modified file 'README'
--- README	2013-01-15 13:22:42 +0000
+++ README	2011-09-26 20:42:19 +0000
@@ -1,11 +1,10 @@
 = Cortex-A String Routines =
 
-This package contains optimised string routines including memcpy(), memset(),
-strcpy(), strlen() for the ARM Cortex-A series of cores.
-
-Various implementations of these routines are provided, including generic
-implementations for ARMv7-A cores with/without Neon, an implementation tuned
-for Cortex-A9 and generic implementations for cores supporting AArch64.
+This package contains optimised string routines including memcpy(),
+memset(), strcpy(), strlen() for the ARM Cortex-A series
+of processors.  These routines were optimised for the Cortex-A9, work
+well on the Cortex-A8, and include variants that can make use of the
+NEON SIMD unit.
 
 == Getting started ==
 First configure and then install libcortex-strings.so.  To make other
@@ -25,10 +24,8 @@
 
 The src directory contains different variants organised by the
 implementation they run on and optional features used.  For example:
-  * src/thumb-2  contains generic non-NEON routines for AArch32 (with Thumb-2).
-  * src/neon  contains NEON based routines for AArch32.
-  * src/linaro-a9  contains tuned routines for Cortex-A9 processors.
-  * src/aarch64  contains generic routines for AArch64.
+  * src/thumb-2  contains generic non-NEON routines for all processors
+  * src/neon  contains NEON based routines for all processors
 
 == Reference versions ==
 reference/ contains versions collected from various popular Open

=== modified file 'benchmarks/multi/harness.c'
--- benchmarks/multi/harness.c	2012-06-12 03:33:40 +0000
+++ benchmarks/multi/harness.c	2011-09-09 00:08:09 +0000
@@ -94,12 +94,6 @@
   SPOIL(memset(dest, 0, n));
 }
 
-/** Stub that calls memcmp */
-static void xmemcmp(void *dest, void *src, size_t n)
-{
-  SPOIL(memcmp(dest, src, n));
-}
-
 /** Stub that calls strcpy */
 static void xstrcpy(void *dest, void *src, size_t n)
 {
@@ -141,7 +135,6 @@
     { "memchr", xmemchr },
     { "memcpy", xmemcpy },
     { "memset", xmemset },
-    { "memcmp", xmemcmp },
     { "strchr", xstrchr },
     { "strcmp", xstrcmp },
     { "strcpy", xstrcpy },

=== modified file 'configure.ac'
--- configure.ac	2012-12-12 02:30:07 +0000
+++ configure.ac	2012-06-07 04:12:11 +0000
@@ -1,6 +1,6 @@
-# Copyright (c) 2011-2012, Linaro Limited
+# Copyright (c) 2011, Linaro Limited
 # All rights reserved.
-#
+# 
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are met:
 #     * Redistributions of source code must retain the above copyright
@@ -11,7 +11,7 @@
 #     * Neither the name of the Linaro nor the
 #       names of its contributors may be used to endorse or promote products
 #       derived from this software without specific prior written permission.
-#
+# 
 # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 # ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 # WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
@@ -21,38 +21,14 @@
 # LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 # ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 
 AC_INIT(cortex-strings, 1.1-2012.06~dev)
 AM_INIT_AUTOMAKE(foreign subdir-objects color-tests dist-bzip2)
 AC_CONFIG_HEADERS([config.h])
 AC_CONFIG_FILES(Makefile)
-AC_CANONICAL_HOST
+AC_PROG_LIBTOOL
 AM_PROG_AS
-AC_PROG_CC
-AC_PROG_LIBTOOL
-
-default_submachine=
-
-case $host in
-aarch64*-*-*)
-  arch=aarch64
-  ;;
-arm*-*-*)
-  arch=aarch32
-  default_submachine=cortex-a9
-  ;;
-x86_64-*-*-*)
-  arch=generic
-  ;;
-*)
-  AC_MSG_ERROR([unknown architecture $host])
-  ;;
-esac
-
-AM_CONDITIONAL([HOST_AARCH32], [test x$arch = xaarch32])
-AM_CONDITIONAL([HOST_AARCH64], [test x$arch = xaarch64])
-AM_CONDITIONAL([HOST_GENERIC], [test x$arch = xgeneric])
 
 AC_ARG_WITH([cpu],
 	    AS_HELP_STRING([--with-cpu=CPU],
@@ -64,10 +40,9 @@
   *) submachine="$withval" ;;
   esac
 ],
-[submachine=$default_submachine])
+[submachine=cortex-a9])
 
 AC_SUBST(submachine)
-AM_CONDITIONAL([WITH_SUBMACHINE], [test x$submachine != x])
 
 AC_ARG_WITH([neon],
             AC_HELP_STRING([--with-neon],

=== modified file 'reference/bionic/memcmp.S'
--- reference/bionic/memcmp.S	2012-06-12 03:32:50 +0000
+++ reference/bionic/memcmp.S	2010-08-30 23:30:25 +0000
@@ -26,9 +26,11 @@
  * SUCH DAMAGE.
  */
 
-	.global memcmp
-	.type memcmp, %function
-	.text
+    .text
+
+    .global memcmp
+    .type memcmp, %function
+    .align 4
 
 /*
  * Optimized memcmp() for ARM9.

=== modified file 'reference/bionic/memcpy.S'
--- reference/bionic/memcpy.S	2012-06-12 03:32:50 +0000
+++ reference/bionic/memcpy.S	2012-06-12 03:20:20 +0000
@@ -26,14 +26,16 @@
  * SUCH DAMAGE.
  */
 
-//#define HAVE_32_BYTE_CACHE_LINE
+#define __ARM_NEON__
+#define HAVE_32_BYTE_CACHE_LINE
 
 #if defined(__ARM_NEON__)
 
+        .text
         .fpu    neon
-	.global memcpy
-	.type memcpy, %function
-	.text
+        .global memcpy
+        .type memcpy, %function
+        .align 4
 
 #ifdef HAVE_32_BYTE_CACHE_LINE
 /* a prefetch distance of 2 cache-lines */

=== modified file 'reference/bionic/strcmp.S'
--- reference/bionic/strcmp.S	2012-06-12 03:32:50 +0000
+++ reference/bionic/strcmp.S	2012-06-12 03:21:36 +0000
@@ -29,7 +29,6 @@
 
 	.text
 	.globl strcmp
-	.type strcmp, %function
 	
 #ifdef __ARMEB__
 #define SHFT2LSB lsl

=== modified file 'reference/bionic/strcpy.S'
--- reference/bionic/strcpy.S	2012-06-12 03:32:50 +0000
+++ reference/bionic/strcpy.S	2012-06-12 03:21:36 +0000
@@ -30,8 +30,6 @@
  */
 
 	.globl strcpy
-	.type strcpy, %function
-	.text
 
 strcpy:
 	.fnstart

=== modified file 'reference/glibc/memcpy.S'
--- reference/glibc/memcpy.S	2012-06-12 03:32:50 +0000
+++ reference/glibc/memcpy.S	2012-06-12 03:20:30 +0000
@@ -49,9 +49,8 @@
 #define push            lsr
 #endif
 
-	.text
-	.global	memcpy
-	.type	memcpy, %function
+		.text
+	.globl memcpy
 
 /* Prototype: void *memcpy(void *dest, const void *src, size_t n); */
 

=== modified file 'reference/glibc/memset.S'
--- reference/glibc/memset.S	2012-06-12 03:32:50 +0000
+++ reference/glibc/memset.S	2012-06-12 03:20:30 +0000
@@ -18,10 +18,8 @@
    02111-1307 USA.  */
 
 /* void *memset (dstpp, c, len) */
-	.text
-	.global	memset
-	.type	memset, %function
-	
+	.globl memset
+
 memset:	
 	mov	r3, r0
 	cmp	r2, #8

=== modified file 'reference/glibc/strlen.S'
--- reference/glibc/strlen.S	2012-06-12 03:32:50 +0000
+++ reference/glibc/strlen.S	2012-06-12 03:20:30 +0000
@@ -21,9 +21,7 @@
  * entry: r0 -> string
  * exit: r0 = len
  */
-	.text
 	.globl strlen
-	.type strlen, %function
 	
 strlen:	
 	bic     r1, r0, $3              @ addr of word containing first byte

=== modified file 'scripts/add-license.sh'
--- scripts/add-license.sh	2012-12-12 00:54:40 +0000
+++ scripts/add-license.sh	2011-09-09 00:08:09 +0000
@@ -31,17 +31,17 @@
 LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
-SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 EOF
 
 # Translate it to C style
 echo "/*" > $f/c
-sed -r 's/(.*)/ * \1/' $f/original | sed -r 's/ +$//' >> $f/c
+sed -r 's/(.*)/ * \1/' $f/original >> $f/c
 echo " */" >> $f/c
 echo >> $f/c
 
 # ...and shell style
-sed -r 's/(.*)/# \1/' $f/original | sed -r 's/ +$//' >> $f/shell
+sed -r 's/(.*)/# \1/' $f/original >> $f/shell
 echo '#' >> $f/shell
 echo >> $f/shell
 

=== modified file 'scripts/bench.py'
--- scripts/bench.py	2012-06-12 03:38:14 +0000
+++ scripts/bench.py	2011-09-25 21:09:13 +0000
@@ -17,19 +17,16 @@
 # Prefix to the executables
 build = '../build/try-'
 
-ALL = 'memchr memcmp memcpy memset strchr strcmp strcpy strlen'
+DEFAULTS = 'memcpy memset memchr strchr strcmp strcpy strlen'
 
 HAS = {
-    'this': 'bounce memchr memcpy memset strchr strcpy strlen',
-    'bionic': 'memcmp memcpy memset strcmp strcpy strlen',
-    'bionic-c': ALL,
-    'csl': 'memcpy memset',
-    'glibc': 'memcpy memset strlen',
-    'glibc-c': ALL,
-    'newlib': 'memcpy strcmp strcpy strlen',
-    'newlib-c': ALL,
-    'newlib-xscale': 'memchr memcpy memset strchr strcmp strcpy strlen',
+    'this': 'bounce ' + DEFAULTS,
+    'bionic': DEFAULTS,
+    'glibc': DEFAULTS,
+    'newlib': DEFAULTS,
+    'newlib-xscale': DEFAULTS,
     'plain': 'memset memcpy strcmp strcpy',
+    'csl': 'memcpy memset'
 }
 
 def run(cache, variant, function, bytes, loops, alignment=8, quiet=False):
@@ -110,14 +107,14 @@
     step1 = 2.0
     # Test intermediate powers of 1.4
     step2 = 1.4
+
+    # Figure out how many steps get us up to the top
+    steps1 = int(round(math.log(top) / math.log(step1)))
+    steps2 = int(round(math.log(top) / math.log(step2)))
     
     bytes = []
-    
-    for step in [step1, step2]:
-        if step:
-            # Figure out how many steps get us up to the top
-            steps = int(round(math.log(top) / math.log(step)))
-            bytes.extend([int(step**x) for x in range(0, steps+1)])
+    bytes.extend([int(step1**x) for x in range(0, steps1+1)])
+    bytes.extend([int(step2**x) for x in range(0, steps2+1)])
 
     alignments = [8, 16, 4, 1, 2, 32]
 
@@ -141,7 +138,7 @@
         run_top(cache)
     finally:
         with open(cachename, 'w') as f:
-            for line in sorted(cache.values()):
+            for line in cache.values():
                 print >> f, line
 
 if __name__ == '__main__':

=== modified file 'scripts/libplot.py'
--- scripts/libplot.py	2012-06-12 03:40:53 +0000
+++ scripts/libplot.py	2011-09-08 03:27:40 +0000
@@ -6,9 +6,6 @@
 Record = collections.namedtuple('Record', 'variant function bytes loops alignment elapsed rest')
 
 
-def make_colours():
-    return iter('m b g r c y k pink orange brown grey'.split())
-
 def parse_value(v):
     """Turn text into a primitive"""
     try:
@@ -31,14 +28,11 @@
     else:
         return sorted(values)
 
-def parse_row(line):
-    return Record(*[parse_value(y) for y in line.split(':')])
-
 def parse():
     """Parse a record file into named tuples, correcting for loop
     overhead along the way.
     """
-    records = [parse_row(x) for x in fileinput.input()]
+    records = [Record(*[parse_value(y) for y in x.split(':')]) for x in fileinput.input()]
 
     # Pull out any bounce values
     costs = {}

=== modified file 'scripts/plot-sizes.py'
--- scripts/plot-sizes.py	2012-06-12 03:40:53 +0000
+++ scripts/plot-sizes.py	2011-09-08 03:27:40 +0000
@@ -19,7 +19,7 @@
         else:
             return '%.1f k' % (v/1024)
 
-def plot(records, function, alignment=None, scale=1):
+def plot(records, function, alignment=None):
     variants = libplot.unique(records, 'variant', prefer='this')
     records = [x for x in records if x.function==function]
 
@@ -32,10 +32,10 @@
 
     bytes = libplot.unique(records, 'bytes')[0]
 
-    colours = libplot.make_colours()
+    colours = iter('bgrcmyk')
     all_x = []
 
-    pylab.figure(1).set_size_inches((6.4*scale, 4.8*scale))
+    pylab.figure(1).set_size_inches((16, 12))
     pylab.clf()
 
     if 'str' in function:
@@ -59,7 +59,7 @@
             pylab.plot(X, Y, c=colour)
             pylab.scatter(X, Y, c=colour, label=variant, edgecolors='none')
 
-    pylab.legend(loc='upper left', ncol=3, prop={'size': 'small'})
+    pylab.legend(loc='upper left', ncol=3)
     pylab.grid()
     pylab.title('%(function)s of %(aalignment)s byte aligned blocks' % locals())
     pylab.xlabel('Size (B)')
@@ -85,11 +85,11 @@
 
     for function in functions:
         for alignment in alignments:
-            for scale in [1, 2.5]:
-                plot(records, function, alignment, scale)
-                pylab.savefig('sizes-%s-%02d-%.1f.png' % (function, alignment, scale), dpi=72)
+            plot(records, function, alignment)
+            pylab.savefig('sizes-%s-%02d.png' % (function, alignment), dpi=72)
 
     pylab.show()
 
 if __name__ == '__main__':
     main()
+

=== removed directory 'src/aarch64'
=== removed file 'src/aarch64/memcmp.S'
--- src/aarch64/memcmp.S	2013-01-07 15:57:20 +0000
+++ src/aarch64/memcmp.S	1970-01-01 00:00:00 +0000
@@ -1,162 +0,0 @@
-/* memcmp - compare memory
-
-   Copyright (c) 2013, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- */
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-/* Parameters and result.  */
-#define src1		x0
-#define src2		x1
-#define limit		x2
-#define result		x0
-
-/* Internal variables.  */
-#define data1		x3
-#define data1w		w3
-#define data2		x4
-#define data2w		w4
-#define has_nul		x5
-#define diff		x6
-#define endloop		x7
-#define tmp1		x8
-#define tmp2		x9
-#define tmp3		x10
-#define pos		x11
-#define limit_wd	x12
-#define mask		x13
-
-def_fn memcmp p2align=6
-	cbz	limit, .Lret0
-	eor	tmp1, src1, src2
-	tst	tmp1, #7
-	b.ne	.Lmisaligned8
-	ands	tmp1, src1, #7
-	b.ne	.Lmutual_align
-	add	limit_wd, limit, #7
-	lsr	limit_wd, limit_wd, #3
-	/* Start of performance-critical section  -- one 64B cache line.  */
-.Lloop_aligned:
-	ldr	data1, [src1], #8
-	ldr	data2, [src2], #8
-.Lstart_realigned:
-	subs	limit_wd, limit_wd, #1
-	eor	diff, data1, data2	/* Non-zero if differences found.  */
-	csinv	endloop, diff, xzr, ne	/* Last Dword or differences.  */
-	cbz	endloop, .Lloop_aligned
-	/* End of performance-critical section  -- one 64B cache line.  */
-
-	/* Not reached the limit, must have found a diff.  */
-	cbnz	limit_wd, .Lnot_limit
-
-	/* Limit % 8 == 0 => all bytes significant.  */
-	ands	limit, limit, #7
-	b.eq	.Lnot_limit
-
-	lsl	limit, limit, #3	/* Bits -> bytes.  */
-	mov	mask, #~0
-#ifdef __AARCH64EB__
-	lsr	mask, mask, limit
-#else
-	lsl	mask, mask, limit
-#endif
-	bic	data1, data1, mask
-	bic	data2, data2, mask
-
-	orr	diff, diff, mask
-.Lnot_limit:
-
-#ifndef	__AARCH64EB__
-	rev	diff, diff
-	rev	data1, data1
-	rev	data2, data2
-#endif
-	/* The MS-non-zero bit of DIFF marks either the first bit
-	   that is different, or the end of the significant data.
-	   Shifting left now will bring the critical information into the
-	   top bits.  */
-	clz	pos, diff
-	lsl	data1, data1, pos
-	lsl	data2, data2, pos
-	/* But we need to zero-extend (char is unsigned) the value and then
-	   perform a signed 32-bit subtraction.  */
-	lsr	data1, data1, #56
-	sub	result, data1, data2, lsr #56
-	ret
-
-.Lmutual_align:
-	/* Sources are mutually aligned, but are not currently at an
-	   alignment boundary.  Round down the addresses and then mask off
-	   the bytes that precede the start point.  */
-	bic	src1, src1, #7
-	bic	src2, src2, #7
-	add	limit, limit, tmp1	/* Adjust the limit for the extra.  */
-	lsl	tmp1, tmp1, #3		/* Bytes beyond alignment -> bits.  */
-	ldr	data1, [src1], #8
-	neg	tmp1, tmp1		/* Bits to alignment -64.  */
-	ldr	data2, [src2], #8
-	mov	tmp2, #~0
-#ifdef __AARCH64EB__
-	/* Big-endian.  Early bytes are at MSB.  */
-	lsl	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#else
-	/* Little-endian.  Early bytes are at LSB.  */
-	lsr	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#endif
-	add	limit_wd, limit, #7
-	orr	data1, data1, tmp2
-	orr	data2, data2, tmp2
-	lsr	limit_wd, limit_wd, #3
-	b	.Lstart_realigned
-
-.Lret0:
-	mov	result, #0
-	ret
-
-	.p2align 6
-.Lmisaligned8:
-	sub	limit, limit, #1
-1:
-	/* Perhaps we can do better than this.  */
-	ldrb	data1w, [src1], #1
-	ldrb	data2w, [src2], #1
-	subs	limit, limit, #1
-	ccmp	data1w, data2w, #0, cs	/* NZCV = 0b0000.  */
-	b.eq	1b
-	sub	result, data1, data2
-	ret
-	.size memcmp, . - memcmp

=== removed file 'src/aarch64/memcpy.S'
--- src/aarch64/memcpy.S	2012-12-12 02:34:13 +0000
+++ src/aarch64/memcpy.S	1970-01-01 00:00:00 +0000
@@ -1,188 +0,0 @@
-/* Copyright (c) 2012, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- * Unaligned accesses
- *
- */
-
-#define dstin	x0
-#define src	x1
-#define count	x2
-#define tmp1	x3
-#define tmp1w	w3
-#define tmp2	x4
-#define tmp2w	w4
-#define tmp3	x5
-#define tmp3w	w5
-#define dst	x6
-
-#define A_l	x7
-#define A_h	x8
-#define B_l	x9
-#define B_h	x10
-#define C_l	x11
-#define C_h	x12
-#define D_l	x13
-#define D_h	x14
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-def_fn memcpy p2align=6
-
-	mov	dst, dstin
-	cmp	count, #64
-	b.ge	.Lcpy_not_short
-	cmp	count, #15
-	b.le	.Ltail15tiny
-
-	/* Deal with small copies quickly by dropping straight into the
-	 * exit block.  */
-.Ltail63:
-	/* Copy up to 48 bytes of data.  At this point we only need the
-	 * bottom 6 bits of count to be accurate.  */
-	ands	tmp1, count, #0x30
-	b.eq	.Ltail15
-	add	dst, dst, tmp1
-	add	src, src, tmp1
-	cmp	tmp1w, #0x20
-	b.eq	1f
-	b.lt	2f
-	ldp	A_l, A_h, [src, #-48]
-	stp	A_l, A_h, [dst, #-48]
-1:
-	ldp	A_l, A_h, [src, #-32]
-	stp	A_l, A_h, [dst, #-32]
-2:
-	ldp	A_l, A_h, [src, #-16]
-	stp	A_l, A_h, [dst, #-16]
-
-.Ltail15:
-	ands	count, count, #15
-	beq	1f
-	add	src, src, count
-	ldp	A_l, A_h, [src, #-16]
-	add	dst, dst, count
-	stp	A_l, A_h, [dst, #-16]
-1:
-	ret
-
-.Ltail15tiny:
-	/* Copy up to 15 bytes of data.  Does not assume additional data
-	   being copied.  */
-	tbz	count, #3, 1f
-	ldr	tmp1, [src], #8
-	str	tmp1, [dst], #8
-1:
-	tbz	count, #2, 1f
-	ldr	tmp1w, [src], #4
-	str	tmp1w, [dst], #4
-1:
-	tbz	count, #1, 1f
-	ldrh	tmp1w, [src], #2
-	strh	tmp1w, [dst], #2
-1:
-	tbz	count, #0, 1f
-	ldrb	tmp1w, [src]
-	strb	tmp1w, [dst]
-1:
-	ret
-
-.Lcpy_not_short:
-	/* We don't much care about the alignment of DST, but we want SRC
-	 * to be 128-bit (16 byte) aligned so that we don't cross cache line
-	 * boundaries on both loads and stores.  */
-	neg	tmp2, src
-	ands	tmp2, tmp2, #15		/* Bytes to reach alignment.  */
-	b.eq	2f
-	sub	count, count, tmp2
-	/* Copy more data than needed; it's faster than jumping
-	 * around copying sub-Quadword quantities.  We know that
-	 * it can't overrun.  */
-	ldp	A_l, A_h, [src]
-	add	src, src, tmp2
-	stp	A_l, A_h, [dst]
-	add	dst, dst, tmp2
-	/* There may be less than 63 bytes to go now.  */
-	cmp	count, #63
-	b.le	.Ltail63
-2:
-	subs	count, count, #128
-	b.ge	.Lcpy_body_large
-	/* Less than 128 bytes to copy, so handle 64 here and then jump
-	 * to the tail.  */
-	ldp	A_l, A_h, [src]
-	ldp	B_l, B_h, [src, #16]
-	ldp	C_l, C_h, [src, #32]
-	ldp	D_l, D_h, [src, #48]
-	stp	A_l, A_h, [dst]
-	stp	B_l, B_h, [dst, #16]
-	stp	C_l, C_h, [dst, #32]
-	stp	D_l, D_h, [dst, #48]
-	tst	count, #0x3f
-	add	src, src, #64
-	add	dst, dst, #64
-	b.ne	.Ltail63
-	ret
-
-	/* Critical loop.  Start at a new cache line boundary.  Assuming
-	 * 64 bytes per line this ensures the entire loop is in one line.  */
-	.p2align 6
-.Lcpy_body_large:
-	/* There are at least 128 bytes to copy.  */
-	ldp	A_l, A_h, [src, #0]
-	sub	dst, dst, #16		/* Pre-bias.  */
-	ldp	B_l, B_h, [src, #16]
-	ldp	C_l, C_h, [src, #32]
-	ldp	D_l, D_h, [src, #48]!	/* src += 64 - Pre-bias.  */
-1:
-	stp	A_l, A_h, [dst, #16]
-	ldp	A_l, A_h, [src, #16]
-	stp	B_l, B_h, [dst, #32]
-	ldp	B_l, B_h, [src, #32]
-	stp	C_l, C_h, [dst, #48]
-	ldp	C_l, C_h, [src, #48]
-	stp	D_l, D_h, [dst, #64]!
-	ldp	D_l, D_h, [src, #64]!
-	subs	count, count, #64
-	b.ge	1b
-	stp	A_l, A_h, [dst, #16]
-	stp	B_l, B_h, [dst, #32]
-	stp	C_l, C_h, [dst, #48]
-	stp	D_l, D_h, [dst, #64]
-	add	src, src, #16
-	add	dst, dst, #64 + 16
-	tst	count, #0x3f
-	b.ne	.Ltail63
-	ret

=== removed file 'src/aarch64/memmove.S'
--- src/aarch64/memmove.S	2013-01-07 14:11:34 +0000
+++ src/aarch64/memmove.S	1970-01-01 00:00:00 +0000
@@ -1,324 +0,0 @@
-/* Copyright (c) 2013, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- * Unaligned accesses
- */
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-/* Parameters and result.  */
-#define dstin	x0
-#define src	x1
-#define count	x2
-#define tmp1	x3
-#define tmp1w	w3
-#define tmp2	x4
-#define tmp2w	w4
-#define tmp3	x5
-#define tmp3w	w5
-#define dst	x6
-
-#define A_l	x7
-#define A_h	x8
-#define B_l	x9
-#define B_h	x10
-#define C_l	x11
-#define C_h	x12
-#define D_l	x13
-#define D_h	x14
-
-def_fn memmove, 6
-	cmp	dstin, src
-	b.lo	.Ldownwards
-	add	tmp1, src, count
-	cmp	dstin, tmp1
-	b.hs	memcpy		/* No overlap.  */
-
-	/* Upwards move with potential overlap.
-	 * Need to move from the tail backwards.  SRC and DST point one
-	 * byte beyond the remaining data to move.  */
-	add	dst, dstin, count
-	add	src, src, count
-	cmp	count, #64
-	b.ge	.Lmov_not_short_up
-
-	/* Deal with small moves quickly by dropping straight into the
-	 * exit block.  */
-.Ltail63up:
-	/* Move up to 48 bytes of data.  At this point we only need the
-	 * bottom 6 bits of count to be accurate.  */
-	ands	tmp1, count, #0x30
-	b.eq	.Ltail15up
-	sub	dst, dst, tmp1
-	sub	src, src, tmp1
-	cmp	tmp1w, #0x20
-	b.eq	1f
-	b.lt	2f
-	ldp	A_l, A_h, [src, #32]
-	stp	A_l, A_h, [dst, #32]
-1:
-	ldp	A_l, A_h, [src, #16]
-	stp	A_l, A_h, [dst, #16]
-2:
-	ldp	A_l, A_h, [src]
-	stp	A_l, A_h, [dst]
-.Ltail15up:
-	/* Move up to 15 bytes of data.  Does not assume additional data
-	 * being moved.  */
-	tbz	count, #3, 1f
-	ldr	tmp1, [src, #-8]!
-	str	tmp1, [dst, #-8]!
-1:
-	tbz	count, #2, 1f
-	ldr	tmp1w, [src, #-4]!
-	str	tmp1w, [dst, #-4]!
-1:
-	tbz	count, #1, 1f
-	ldrh	tmp1w, [src, #-2]!
-	strh	tmp1w, [dst, #-2]!
-1:
-	tbz	count, #0, 1f
-	ldrb	tmp1w, [src, #-1]
-	strb	tmp1w, [dst, #-1]
-1:
-	ret
-
-.Lmov_not_short_up:
-	/* We don't much care about the alignment of DST, but we want SRC
-	 * to be 128-bit (16 byte) aligned so that we don't cross cache line
-	 * boundaries on both loads and stores.  */
-	ands	tmp2, src, #15		/* Bytes to reach alignment.  */
-	b.eq	2f
-	sub	count, count, tmp2
-	/* Move enough data to reach alignment; unlike memcpy, we have to
-	 * be aware of the overlap, which means we can't move data twice.  */
-	tbz	tmp2, #3, 1f
-	ldr	tmp1, [src, #-8]!
-	str	tmp1, [dst, #-8]!
-1:
-	tbz	tmp2, #2, 1f
-	ldr	tmp1w, [src, #-4]!
-	str	tmp1w, [dst, #-4]!
-1:
-	tbz	tmp2, #1, 1f
-	ldrh	tmp1w, [src, #-2]!
-	strh	tmp1w, [dst, #-2]!
-1:
-	tbz	tmp2, #0, 1f
-	ldrb	tmp1w, [src, #-1]!
-	strb	tmp1w, [dst, #-1]!
-1:
-
-	/* There may be less than 63 bytes to go now.  */
-	cmp	count, #63
-	b.le	.Ltail63up
-2:
-	subs	count, count, #128
-	b.ge	.Lmov_body_large_up
-	/* Less than 128 bytes to move, so handle 64 here and then jump
-	 * to the tail.  */
-	ldp	A_l, A_h, [src, #-64]!
-	ldp	B_l, B_h, [src, #16]
-	ldp	C_l, C_h, [src, #32]
-	ldp	D_l, D_h, [src, #48]
-	stp	A_l, A_h, [dst, #-64]!
-	stp	B_l, B_h, [dst, #16]
-	stp	C_l, C_h, [dst, #32]
-	stp	D_l, D_h, [dst, #48]
-	tst	count, #0x3f
-	b.ne	.Ltail63up
-	ret
-
-	/* Critical loop.  Start at a new Icache line boundary.  Assuming
-	 * 64 bytes per line this ensures the entire loop is in one line.  */
-	.p2align 6
-.Lmov_body_large_up:
-	/* There are at least 128 bytes to move.  */
-	ldp	A_l, A_h, [src, #-16]
-	ldp	B_l, B_h, [src, #-32]
-	ldp	C_l, C_h, [src, #-48]
-	ldp	D_l, D_h, [src, #-64]!
-1:
-	stp	A_l, A_h, [dst, #-16]
-	ldp	A_l, A_h, [src, #-16]
-	stp	B_l, B_h, [dst, #-32]
-	ldp	B_l, B_h, [src, #-32]
-	stp	C_l, C_h, [dst, #-48]
-	ldp	C_l, C_h, [src, #-48]
-	stp	D_l, D_h, [dst, #-64]!
-	ldp	D_l, D_h, [src, #-64]!
-	subs	count, count, #64
-	b.ge	1b
-	stp	A_l, A_h, [dst, #-16]
-	stp	B_l, B_h, [dst, #-32]
-	stp	C_l, C_h, [dst, #-48]
-	stp	D_l, D_h, [dst, #-64]!
-	tst	count, #0x3f
-	b.ne	.Ltail63up
-	ret
-
-
-.Ldownwards:
-	/* For a downwards move we can safely use memcpy provided that
-	 * DST is more than 16 bytes away from SRC.  */
-	sub	tmp1, src, #16
-	cmp	dstin, tmp1
-	b.ls	memcpy		/* May overlap, but not critically.  */
-
-	mov	dst, dstin	/* Preserve DSTIN for return value.  */
-	cmp	count, #64
-	b.ge	.Lmov_not_short_down
-
-	/* Deal with small moves quickly by dropping straight into the
-	 * exit block.  */
-.Ltail63down:
-	/* Move up to 48 bytes of data.  At this point we only need the
-	 * bottom 6 bits of count to be accurate.  */
-	ands	tmp1, count, #0x30
-	b.eq	.Ltail15down
-	add	dst, dst, tmp1
-	add	src, src, tmp1
-	cmp	tmp1w, #0x20
-	b.eq	1f
-	b.lt	2f
-	ldp	A_l, A_h, [src, #-48]
-	stp	A_l, A_h, [dst, #-48]
-1:
-	ldp	A_l, A_h, [src, #-32]
-	stp	A_l, A_h, [dst, #-32]
-2:
-	ldp	A_l, A_h, [src, #-16]
-	stp	A_l, A_h, [dst, #-16]
-.Ltail15down:
-	/* Move up to 15 bytes of data.  Does not assume additional data
-	   being moved.  */
-	tbz	count, #3, 1f
-	ldr	tmp1, [src], #8
-	str	tmp1, [dst], #8
-1:
-	tbz	count, #2, 1f
-	ldr	tmp1w, [src], #4
-	str	tmp1w, [dst], #4
-1:
-	tbz	count, #1, 1f
-	ldrh	tmp1w, [src], #2
-	strh	tmp1w, [dst], #2
-1:
-	tbz	count, #0, 1f
-	ldrb	tmp1w, [src]
-	strb	tmp1w, [dst]
-1:
-	ret
-
-.Lmov_not_short_down:
-	/* We don't much care about the alignment of DST, but we want SRC
-	 * to be 128-bit (16 byte) aligned so that we don't cross cache line
-	 * boundaries on both loads and stores.  */
-	neg	tmp2, src
-	ands	tmp2, tmp2, #15		/* Bytes to reach alignment.  */
-	b.eq	2f
-	sub	count, count, tmp2
-	/* Move enough data to reach alignment; unlike memcpy, we have to
-	 * be aware of the overlap, which means we can't move data twice.  */
-	tbz	tmp2, #3, 1f
-	ldr	tmp1, [src], #8
-	str	tmp1, [dst], #8
-1:
-	tbz	tmp2, #2, 1f
-	ldr	tmp1w, [src], #4
-	str	tmp1w, [dst], #4
-1:
-	tbz	tmp2, #1, 1f
-	ldrh	tmp1w, [src], #2
-	strh	tmp1w, [dst], #2
-1:
-	tbz	tmp2, #0, 1f
-	ldrb	tmp1w, [src], #1
-	strb	tmp1w, [dst], #1
-1:
-
-	/* There may be less than 63 bytes to go now.  */
-	cmp	count, #63
-	b.le	.Ltail63down
-2:
-	subs	count, count, #128
-	b.ge	.Lmov_body_large_down
-	/* Less than 128 bytes to move, so handle 64 here and then jump
-	 * to the tail.  */
-	ldp	A_l, A_h, [src]
-	ldp	B_l, B_h, [src, #16]
-	ldp	C_l, C_h, [src, #32]
-	ldp	D_l, D_h, [src, #48]
-	stp	A_l, A_h, [dst]
-	stp	B_l, B_h, [dst, #16]
-	stp	C_l, C_h, [dst, #32]
-	stp	D_l, D_h, [dst, #48]
-	tst	count, #0x3f
-	add	src, src, #64
-	add	dst, dst, #64
-	b.ne	.Ltail63down
-	ret
-
-	/* Critical loop.  Start at a new cache line boundary.  Assuming
-	 * 64 bytes per line this ensures the entire loop is in one line.  */
-	.p2align 6
-.Lmov_body_large_down:
-	/* There are at least 128 bytes to move.  */
-	ldp	A_l, A_h, [src, #0]
-	sub	dst, dst, #16		/* Pre-bias.  */
-	ldp	B_l, B_h, [src, #16]
-	ldp	C_l, C_h, [src, #32]
-	ldp	D_l, D_h, [src, #48]!	/* src += 64 - Pre-bias.  */
-1:
-	stp	A_l, A_h, [dst, #16]
-	ldp	A_l, A_h, [src, #16]
-	stp	B_l, B_h, [dst, #32]
-	ldp	B_l, B_h, [src, #32]
-	stp	C_l, C_h, [dst, #48]
-	ldp	C_l, C_h, [src, #48]
-	stp	D_l, D_h, [dst, #64]!
-	ldp	D_l, D_h, [src, #64]!
-	subs	count, count, #64
-	b.ge	1b
-	stp	A_l, A_h, [dst, #16]
-	stp	B_l, B_h, [dst, #32]
-	stp	C_l, C_h, [dst, #48]
-	stp	D_l, D_h, [dst, #64]
-	add	src, src, #16
-	add	dst, dst, #64 + 16
-	tst	count, #0x3f
-	b.ne	.Ltail63down
-	ret
-	.size memmove, . - memmove

=== removed file 'src/aarch64/memset.S'
--- src/aarch64/memset.S	2012-12-12 02:34:13 +0000
+++ src/aarch64/memset.S	1970-01-01 00:00:00 +0000
@@ -1,241 +0,0 @@
-/* Copyright (c) 2012, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- * Unaligned accesses
- *
- */
-
-
-/* By default we assume that the DC instruction can be used to zero
-   data blocks more efficiently.  In some circumstances this might be
-   unsafe, for example in an asymmetric multiprocessor environment with
-   different DC clear lengths (neither the upper nor lower lengths are
-   safe to use).  The feature can be disabled by defining DONT_USE_DC.
-
-   If code may be run in a virtualized environment, then define
-   MAYBE_VIRT.  This will cause the code to cache the system register
-   values rather than re-reading them each call.  */
-
-#define dstin		x0
-#define val		w1
-#define count		x2
-#define tmp1		x3
-#define tmp1w		w3
-#define tmp2		x4
-#define tmp2w		w4
-#define zva_len_x	x5
-#define zva_len		w5
-#define zva_bits_x	x6
-
-#define A_l		x7
-#define A_lw		w7
-#define dst		x8
-#define tmp3w		w9
-
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-def_fn memset p2align=6
-
-	mov	dst, dstin		/* Preserve return value.  */
-	ands	A_lw, val, #255
-#ifndef DONT_USE_DC
-	b.eq	.Lzero_mem
-#endif
-	orr	A_lw, A_lw, A_lw, lsl #8
-	orr	A_lw, A_lw, A_lw, lsl #16
-	orr	A_l, A_l, A_l, lsl #32
-.Ltail_maybe_long:
-	cmp	count, #64
-	b.ge	.Lnot_short
-.Ltail_maybe_tiny:
-	cmp	count, #15
-	b.le	.Ltail15tiny
-.Ltail63:
-	ands	tmp1, count, #0x30
-	b.eq	.Ltail15
-	add	dst, dst, tmp1
-	cmp	tmp1w, #0x20
-	b.eq	1f
-	b.lt	2f
-	stp	A_l, A_l, [dst, #-48]
-1:
-	stp	A_l, A_l, [dst, #-32]
-2:
-	stp	A_l, A_l, [dst, #-16]
-
-.Ltail15:
-	and	count, count, #15
-	add	dst, dst, count
-	stp	A_l, A_l, [dst, #-16]	/* Repeat some/all of last store. */
-	ret
-
-.Ltail15tiny:
-	/* Set up to 15 bytes.  Does not assume earlier memory
-	   being set.  */
-	tbz	count, #3, 1f
-	str	A_l, [dst], #8
-1:
-	tbz	count, #2, 1f
-	str	A_lw, [dst], #4
-1:
-	tbz	count, #1, 1f
-	strh	A_lw, [dst], #2
-1:
-	tbz	count, #0, 1f
-	strb	A_lw, [dst]
-1:
-	ret
-
-	/* Critical loop.  Start at a new cache line boundary.  Assuming
-	 * 64 bytes per line, this ensures the entire loop is in one line.  */
-	.p2align 6
-.Lnot_short:
-	neg	tmp2, dst
-	ands	tmp2, tmp2, #15
-	b.eq	2f
-	/* Bring DST to 128-bit (16-byte) alignment.  We know that there's
-	 * more than that to set, so we simply store 16 bytes and advance by
-	 * the amount required to reach alignment.  */
-	sub	count, count, tmp2
-	stp	A_l, A_l, [dst]
-	add	dst, dst, tmp2
-	/* There may be less than 63 bytes to go now.  */
-	cmp	count, #63
-	b.le	.Ltail63
-2:
-	sub	dst, dst, #16		/* Pre-bias.  */
-	sub	count, count, #64
-1:
-	stp	A_l, A_l, [dst, #16]
-	stp	A_l, A_l, [dst, #32]
-	stp	A_l, A_l, [dst, #48]
-	stp	A_l, A_l, [dst, #64]!
-	subs	count, count, #64
-	b.ge	1b
-	tst	count, #0x3f
-	add	dst, dst, #16
-	b.ne	.Ltail63
-	ret
-
-#ifndef DONT_USE_DC
-	/* For zeroing memory, check to see if we can use the ZVA feature to
-	 * zero entire 'cache' lines.  */
-.Lzero_mem:
-	mov	A_l, #0
-	cmp	count, #63
-	b.le	.Ltail_maybe_tiny
-	neg	tmp2, dst
-	ands	tmp2, tmp2, #15
-	b.eq	1f
-	sub	count, count, tmp2
-	stp	A_l, A_l, [dst]
-	add	dst, dst, tmp2
-	cmp	count, #63
-	b.le	.Ltail63
-1:
-	/* For zeroing small amounts of memory, it's not worth setting up
-	 * the line-clear code.  */
-	cmp	count, #128
-	b.lt	.Lnot_short
-#ifdef MAYBE_VIRT
-	/* For efficiency when virtualized, we cache the ZVA capability.  */
-	adrp	tmp2, .Lcache_clear
-	ldr	zva_len, [tmp2, #:lo12:.Lcache_clear]
-	tbnz	zva_len, #31, .Lnot_short
-	cbnz	zva_len, .Lzero_by_line
-	mrs	tmp1, dczid_el0
-	tbz	tmp1, #4, 1f
-	/* ZVA not available.  Remember this for next time.  */
-	mov	zva_len, #~0
-	str	zva_len, [tmp2, #:lo12:.Lcache_clear]
-	b	.Lnot_short
-1:
-	mov	tmp3w, #4
-	and	zva_len, tmp1w, #15	/* Safety: other bits reserved.  */
-	lsl	zva_len, tmp3w, zva_len
-	str	zva_len, [tmp2, #:lo12:.Lcache_clear]
-#else
-	mrs	tmp1, dczid_el0
-	tbnz	tmp1, #4, .Lnot_short
-	mov	tmp3w, #4
-	and	zva_len, tmp1w, #15	/* Safety: other bits reserved.  */
-	lsl	zva_len, tmp3w, zva_len
-#endif
-
-.Lzero_by_line:
-	/* Compute how far we need to go to become suitably aligned.  We're
-	 * already at quad-word alignment.  */
-	cmp	count, zva_len_x
-	b.lt	.Lnot_short		/* Not enough to reach alignment.  */
-	sub	zva_bits_x, zva_len_x, #1
-	neg	tmp2, dst
-	ands	tmp2, tmp2, zva_bits_x
-	b.eq	1f			/* Already aligned.  */
-	/* Not aligned, check that there's enough to copy after alignment.  */
-	sub	tmp1, count, tmp2
-	cmp	tmp1, #64
-	ccmp	tmp1, zva_len_x, #8, ge	/* NZCV=0b1000 */
-	b.lt	.Lnot_short
-	/* We know that there's at least 64 bytes to zero and that it's safe
-	 * to overrun by 64 bytes.  */
-	mov	count, tmp1
-2:
-	stp	A_l, A_l, [dst]
-	stp	A_l, A_l, [dst, #16]
-	stp	A_l, A_l, [dst, #32]
-	subs	tmp2, tmp2, #64
-	stp	A_l, A_l, [dst, #48]
-	add	dst, dst, #64
-	b.ge	2b
-	/* We've overrun a bit, so adjust dst downwards.  */
-	add	dst, dst, tmp2
-1:
-	sub	count, count, zva_len_x
-3:
-	dc	zva, dst
-	add	dst, dst, zva_len_x
-	subs	count, count, zva_len_x
-	b.ge	3b
-	ands	count, count, zva_bits_x
-	b.ne	.Ltail_maybe_long
-	ret
-#ifdef MAYBE_VIRT
-	.bss
-	.p2align 2
-.Lcache_clear:
-	.space 4
-#endif
-#endif /* DONT_USE_DC */

=== removed file 'src/aarch64/strcmp.S'
--- src/aarch64/strcmp.S	2012-12-12 02:34:13 +0000
+++ src/aarch64/strcmp.S	1970-01-01 00:00:00 +0000
@@ -1,166 +0,0 @@
-/* Copyright (c) 2012, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- */
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-#define REP8_01 0x0101010101010101
-#define REP8_7f 0x7f7f7f7f7f7f7f7f
-#define REP8_80 0x8080808080808080
-
-/* Parameters and result.  */
-#define src1		x0
-#define src2		x1
-#define result		x0
-
-/* Internal variables.  */
-#define data1		x2
-#define data1w		w2
-#define data2		x3
-#define data2w		w3
-#define has_nul		x4
-#define diff		x5
-#define syndrome	x6
-#define tmp1		x7
-#define tmp2		x8
-#define tmp3		x9
-#define zeroones	x10
-#define pos		x11
-
-	/* Start of performance-critical section  -- one 64B cache line.  */
-def_fn strcmp p2align=6
-	eor	tmp1, src1, src2
-	mov	zeroones, #REP8_01
-	tst	tmp1, #7
-	b.ne	.Lmisaligned8
-	ands	tmp1, src1, #7
-	b.ne	.Lmutual_align
-	/* NUL detection works on the principle that (X - 1) & (~X) & 0x80
-	   (=> (X - 1) & ~(X | 0x7f)) is non-zero iff a byte is zero, and
-	   can be done in parallel across the entire word.  */
-.Lloop_aligned:
-	ldr	data1, [src1], #8
-	ldr	data2, [src2], #8
-.Lstart_realigned:
-	sub	tmp1, data1, zeroones
-	orr	tmp2, data1, #REP8_7f
-	eor	diff, data1, data2	/* Non-zero if differences found.  */
-	bic	has_nul, tmp1, tmp2	/* Non-zero if NUL terminator.  */
-	orr	syndrome, diff, has_nul
-	cbz	syndrome, .Lloop_aligned
-	/* End of performance-critical section  -- one 64B cache line.  */
-
-#ifndef	__AARCH64EB__
-	rev	syndrome, syndrome
-	rev	data1, data1
-	/* The MS-non-zero bit of the syndrome marks either the first bit
-	   that is different, or the top bit of the first zero byte.
-	   Shifting left now will bring the critical information into the
-	   top bits.  */
-	clz	pos, syndrome
-	rev	data2, data2
-	lsl	data1, data1, pos
-	lsl	data2, data2, pos
-	/* But we need to zero-extend (char is unsigned) the value and then
-	   perform a signed 32-bit subtraction.  */
-	lsr	data1, data1, #56
-	sub	result, data1, data2, lsr #56
-	ret
-#else
-	/* For big-endian we cannot use the trick with the syndrome value
-	   as carry-propagation can corrupt the upper bits if the trailing
-	   bytes in the string contain 0x01.  */
-	/* However, if there is no NUL byte in the dword, we can generate
-	   the result directly.  We can't just subtract the bytes as the
-	   MSB might be significant.  */
-	cbnz	has_nul, 1f
-	cmp	data1, data2
-	cset	result, ne
-	cneg	result, result, lo
-	ret
-1:
-	/* Re-compute the NUL-byte detection, using a byte-reversed value.  */
-	rev	tmp3, data1
-	sub	tmp1, tmp3, zeroones
-	orr	tmp2, tmp3, #REP8_7f
-	bic	has_nul, tmp1, tmp2
-	rev	has_nul, has_nul
-	orr	syndrome, diff, has_nul
-	clz	pos, syndrome
-	/* The MS-non-zero bit of the syndrome marks either the first bit
-	   that is different, or the top bit of the first zero byte.
-	   Shifting left now will bring the critical information into the
-	   top bits.  */
-	lsl	data1, data1, pos
-	lsl	data2, data2, pos
-	/* But we need to zero-extend (char is unsigned) the value and then
-	   perform a signed 32-bit subtraction.  */
-	lsr	data1, data1, #56
-	sub	result, data1, data2, lsr #56
-	ret
-#endif
-
-.Lmutual_align:
-	/* Sources are mutually aligned, but are not currently at an
-	   alignment boundary.  Round down the addresses and then mask off
-	   the bytes that preceed the start point.  */
-	bic	src1, src1, #7
-	bic	src2, src2, #7
-	lsl	tmp1, tmp1, #3		/* Bytes beyond alignment -> bits.  */
-	ldr	data1, [src1], #8
-	neg	tmp1, tmp1		/* Bits to alignment -64.  */
-	ldr	data2, [src2], #8
-	mov	tmp2, #~0
-#ifdef __AARCH64EB__
-	/* Big-endian.  Early bytes are at MSB.  */
-	lsl	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#else
-	/* Little-endian.  Early bytes are at LSB.  */
-	lsr	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#endif
-	orr	data1, data1, tmp2
-	orr	data2, data2, tmp2
-	b	.Lstart_realigned
-
-.Lmisaligned8:
-	/* We can do better than this.  */
-	ldrb	data1w, [src1], #1
-	ldrb	data2w, [src2], #1
-	cmp	data1w, #1
-	ccmp	data1w, data2w, #0, cs	/* NZCV = 0b0000.  */
-	b.eq	.Lmisaligned8
-	sub	result, data1, data2
-	ret

=== removed file 'src/aarch64/strlen.S'
--- src/aarch64/strlen.S	2013-01-07 14:12:23 +0000
+++ src/aarch64/strlen.S	1970-01-01 00:00:00 +0000
@@ -1,131 +0,0 @@
-/* Copyright (c) 2013, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- */
-
-/* Arguments and results.  */
-#define srcin		x0
-#define len		x0
-
-/* Locals and temporaries.  */
-#define src		x1
-#define data1		x2
-#define data2		x3
-#define data2a		x4
-#define has_nul1	x5
-#define has_nul2	x6
-#define tmp1		x7
-#define tmp2		x8
-#define tmp3		x9
-#define tmp4		x10
-#define zeroones	x11
-#define pos		x12
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-#define REP8_01 0x0101010101010101
-#define REP8_7f 0x7f7f7f7f7f7f7f7f
-#define REP8_80 0x8080808080808080
-
-	/* Start of critial section -- keep to one 64Byte cache line.  */
-def_fn strlen p2align=6
-	mov	zeroones, #REP8_01
-	bic	src, srcin, #15
-	ands	tmp1, srcin, #15
-	b.ne	.Lmisaligned
-	/* NUL detection works on the principle that (X - 1) & (~X) & 0x80
-	   (=> (X - 1) & ~(X | 0x7f)) is non-zero iff a byte is zero, and
-	   can be done in parallel across the entire word.  */
-	/* The inner loop deals with two Dwords at a time.  This has a
-	   slightly higher start-up cost, but we should win quite quickly,
-	   especially on cores with a high number of issue slots per
-	   cycle, as we get much better parallelism out of the operations.  */
-.Lloop:
-	ldp	data1, data2, [src], #16
-.Lrealigned:
-	sub	tmp1, data1, zeroones
-	orr	tmp2, data1, #REP8_7f
-	sub	tmp3, data2, zeroones
-	orr	tmp4, data2, #REP8_7f
-	bic	has_nul1, tmp1, tmp2
-	bics	has_nul2, tmp3, tmp4
-	ccmp	has_nul1, #0, #0, eq	/* NZCV = 0000  */
-	b.eq	.Lloop
-	/* End of critical section -- keep to one 64Byte cache line.  */
-
-	sub	len, src, srcin
-	cbz	has_nul1, .Lnul_in_data2
-#ifdef __AARCH64EB__
-	mov	data2, data1
-#endif
-	sub	len, len, #8
-	mov	has_nul2, has_nul1
-.Lnul_in_data2:
-#ifdef __AARCH64EB__
-	/* For big-endian, carry propagation (if the final byte in the
-	   string is 0x01) means we cannot use has_nul directly.  The
-	   easiest way to get the correct byte is to byte-swap the data
-	   and calculate the syndrome a second time.  */
-	rev	data2, data2
-	sub	tmp1, data2, zeroones
-	orr	tmp2, data2, #REP8_7f
-	bic	has_nul2, tmp1, tmp2
-#endif
-	sub	len, len, #8
-	rev	has_nul2, has_nul2
-	clz	pos, has_nul2
-	add	len, len, pos, lsr #3		/* Bits to bytes.  */
-	ret
-
-.Lmisaligned:
-	cmp	tmp1, #8
-	neg	tmp1, tmp1
-	ldp	data1, data2, [src], #16
-	lsl	tmp1, tmp1, #3		/* Bytes beyond alignment -> bits.  */
-	mov	tmp2, #~0
-#ifdef __AARCH64EB__
-	/* Big-endian.  Early bytes are at MSB.  */
-	lsl	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#else
-	/* Little-endian.  Early bytes are at LSB.  */
-	lsr	tmp2, tmp2, tmp1	/* Shift (tmp1 & 63).  */
-#endif
-	orr	data1, data1, tmp2
-	orr	data2a, data2, tmp2
-	csinv	data1, data1, xzr, le
-	csel	data2, data2, data2a, le
-	b	.Lrealigned
-
-	.size	strlen, . - strlen

=== removed file 'src/aarch64/strncmp.S'
--- src/aarch64/strncmp.S	2013-01-16 20:55:21 +0000
+++ src/aarch64/strncmp.S	1970-01-01 00:00:00 +0000
@@ -1,222 +0,0 @@
-/* Copyright (c) 2013, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- */
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-#define REP8_01 0x0101010101010101
-#define REP8_7f 0x7f7f7f7f7f7f7f7f
-#define REP8_80 0x8080808080808080
-
-/* Parameters and result.  */
-#define src1		x0
-#define src2		x1
-#define limit		x2
-#define result		x0
-
-/* Internal variables.  */
-#define data1		x3
-#define data1w		w3
-#define data2		x4
-#define data2w		w4
-#define has_nul		x5
-#define diff		x6
-#define syndrome	x7
-#define tmp1		x8
-#define tmp2		x9
-#define tmp3		x10
-#define zeroones	x11
-#define pos		x12
-#define limit_wd	x13
-#define mask		x14
-#define endloop		x15
-
-	.text
-	.p2align 6
-	.rep 7
-	nop	/* Pad so that the loop below fits a cache line.  */
-	.endr
-def_fn strncmp
-	cbz	limit, .Lret0
-	eor	tmp1, src1, src2
-	mov	zeroones, #REP8_01
-	tst	tmp1, #7
-	b.ne	.Lmisaligned8
-	ands	tmp1, src1, #7
-	b.ne	.Lmutual_align
-	/* Calculate the number of full and partial words -1.  */
-	sub	limit_wd, limit, #1	/* limit != 0, so no underflow.  */
-	lsr	limit_wd, limit_wd, #3	/* Convert to Dwords.  */
-
-	/* NUL detection works on the principle that (X - 1) & (~X) & 0x80
-	   (=> (X - 1) & ~(X | 0x7f)) is non-zero iff a byte is zero, and
-	   can be done in parallel across the entire word.  */
-	/* Start of performance-critical section  -- one 64B cache line.  */
-.Lloop_aligned:
-	ldr	data1, [src1], #8
-	ldr	data2, [src2], #8
-.Lstart_realigned:
-	subs	limit_wd, limit_wd, #1
-	sub	tmp1, data1, zeroones
-	orr	tmp2, data1, #REP8_7f
-	eor	diff, data1, data2	/* Non-zero if differences found.  */
-	csinv	endloop, diff, xzr, pl	/* Last Dword or differences.  */
-	bics	has_nul, tmp1, tmp2	/* Non-zero if NUL terminator.  */
-	ccmp	endloop, #0, #0, eq
-	b.eq	.Lloop_aligned
-	/* End of performance-critical section  -- one 64B cache line.  */
-
-	/* Not reached the limit, must have found the end or a diff.  */
-	tbz	limit_wd, #63, .Lnot_limit
-
-	/* Limit % 8 == 0 => all bytes significant.  */
-	ands	limit, limit, #7
-	b.eq	.Lnot_limit
-
-	lsl	limit, limit, #3	/* Bits -> bytes.  */
-	mov	mask, #~0
-#ifdef __AARCH64EB__
-	lsr	mask, mask, limit
-#else
-	lsl	mask, mask, limit
-#endif
-	bic	data1, data1, mask
-	bic	data2, data2, mask
-
-	/* Make sure that the NUL byte is marked in the syndrome.  */
-	orr	has_nul, has_nul, mask
-
-.Lnot_limit:
-	orr	syndrome, diff, has_nul
-
-#ifndef	__AARCH64EB__
-	rev	syndrome, syndrome
-	rev	data1, data1
-	/* The MS-non-zero bit of the syndrome marks either the first bit
-	   that is different, or the top bit of the first zero byte.
-	   Shifting left now will bring the critical information into the
-	   top bits.  */
-	clz	pos, syndrome
-	rev	data2, data2
-	lsl	data1, data1, pos
-	lsl	data2, data2, pos
-	/* But we need to zero-extend (char is unsigned) the value and then
-	   perform a signed 32-bit subtraction.  */
-	lsr	data1, data1, #56
-	sub	result, data1, data2, lsr #56
-	ret
-#else
-	/* For big-endian we cannot use the trick with the syndrome value
-	   as carry-propagation can corrupt the upper bits if the trailing
-	   bytes in the string contain 0x01.  */
-	/* However, if there is no NUL byte in the dword, we can generate
-	   the result directly.  We can't just subtract the bytes as the
-	   MSB might be significant.  */
-	cbnz	has_nul, 1f
-	cmp	data1, data2
-	cset	result, ne
-	cneg	result, result, lo
-	ret
-1:
-	/* Re-compute the NUL-byte detection, using a byte-reversed value.  */
-	rev	tmp3, data1
-	sub	tmp1, tmp3, zeroones
-	orr	tmp2, tmp3, #REP8_7f
-	bic	has_nul, tmp1, tmp2
-	rev	has_nul, has_nul
-	orr	syndrome, diff, has_nul
-	clz	pos, syndrome
-	/* The MS-non-zero bit of the syndrome marks either the first bit
-	   that is different, or the top bit of the first zero byte.
-	   Shifting left now will bring the critical information into the
-	   top bits.  */
-	lsl	data1, data1, pos
-	lsl	data2, data2, pos
-	/* But we need to zero-extend (char is unsigned) the value and then
-	   perform a signed 32-bit subtraction.  */
-	lsr	data1, data1, #56
-	sub	result, data1, data2, lsr #56
-	ret
-#endif
-
-.Lmutual_align:
-	/* Sources are mutually aligned, but are not currently at an
-	   alignment boundary.  Round down the addresses and then mask off
-	   the bytes that precede the start point.
-	   We also need to adjust the limit calculations, but without
-	   overflowing if the limit is near ULONG_MAX.  */
-	bic	src1, src1, #7
-	bic	src2, src2, #7
-	ldr	data1, [src1], #8
-	neg	tmp3, tmp1, lsl #3	/* 64 - bits(bytes beyond align). */
-	ldr	data2, [src2], #8
-	mov	tmp2, #~0
-	sub	limit_wd, limit, #1	/* limit != 0, so no underflow.  */
-#ifdef __AARCH64EB__
-	/* Big-endian.  Early bytes are at MSB.  */
-	lsl	tmp2, tmp2, tmp3	/* Shift (tmp1 & 63).  */
-#else
-	/* Little-endian.  Early bytes are at LSB.  */
-	lsr	tmp2, tmp2, tmp3	/* Shift (tmp1 & 63).  */
-#endif
-	and	tmp3, limit_wd, #7
-	lsr	limit_wd, limit_wd, #3
-	/* Adjust the limit. Only low 3 bits used, so overflow irrelevant.  */
-	add	limit, limit, tmp1
-	add	tmp3, tmp3, tmp1
-	orr	data1, data1, tmp2
-	orr	data2, data2, tmp2
-	add	limit_wd, limit_wd, tmp3, lsr #3
-	b	.Lstart_realigned
-
-.Lret0:
-	mov	result, #0
-	ret
-
-	.p2align 6
-.Lmisaligned8:
-	sub	limit, limit, #1
-1:
-	/* Perhaps we can do better than this.  */
-	ldrb	data1w, [src1], #1
-	ldrb	data2w, [src2], #1
-	subs	limit, limit, #1
-	ccmp	data1w, #1, #0, cs	/* NZCV = 0b0000.  */
-	ccmp	data1w, data2w, #0, cs	/* NZCV = 0b0000.  */
-	b.eq	1b
-	sub	result, data1, data2
-	ret
-	.size strncmp, . - strncmp

=== removed file 'src/aarch64/strnlen.S'
--- src/aarch64/strnlen.S	2013-01-16 20:55:59 +0000
+++ src/aarch64/strnlen.S	1970-01-01 00:00:00 +0000
@@ -1,181 +0,0 @@
-/* strnlen - calculate the length of a string with limit.
-
-   Copyright (c) 2013, Linaro Limited
-   All rights reserved.
-
-   Redistribution and use in source and binary forms, with or without
-   modification, are permitted provided that the following conditions are met:
-       * Redistributions of source code must retain the above copyright
-         notice, this list of conditions and the following disclaimer.
-       * Redistributions in binary form must reproduce the above copyright
-         notice, this list of conditions and the following disclaimer in the
-         documentation and/or other materials provided with the distribution.
-       * Neither the name of the Linaro nor the
-         names of its contributors may be used to endorse or promote products
-         derived from this software without specific prior written permission.
-
-   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-   HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-   LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-   DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-   THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-   OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. */
-
-/* Assumptions:
- *
- * ARMv8-a, AArch64
- */
-
-/* Arguments and results.  */
-#define srcin		x0
-#define len		x0
-#define limit		x1
-
-/* Locals and temporaries.  */
-#define src		x2
-#define data1		x3
-#define data2		x4
-#define data2a		x5
-#define has_nul1	x6
-#define has_nul2	x7
-#define tmp1		x8
-#define tmp2		x9
-#define tmp3		x10
-#define tmp4		x11
-#define zeroones	x12
-#define pos		x13
-#define limit_wd	x14
-
-	.macro def_fn f p2align=0
-	.text
-	.p2align \p2align
-	.global \f
-	.type \f, %function
-\f:
-	.endm
-
-#define REP8_01 0x0101010101010101
-#define REP8_7f 0x7f7f7f7f7f7f7f7f
-#define REP8_80 0x8080808080808080
-
-	.text
-	.p2align	6
-.Lstart:
-	/* Pre-pad to ensure critical loop begins an icache line.  */
-	.rep 7
-	nop
-	.endr
-	/* Put this code here to avoid wasting more space with pre-padding.  */
-.Lhit_limit:
-	mov	len, limit
-	ret
-
-def_fn strnlen
-	cbz	limit, .Lhit_limit
-	mov	zeroones, #REP8_01
-	bic	src, srcin, #15
-	ands	tmp1, srcin, #15
-	b.ne	.Lmisaligned
-	/* Calculate the number of full and partial words -1.  */
-	sub	limit_wd, limit, #1	/* Limit != 0, so no underflow.  */
-	lsr	limit_wd, limit_wd, #4	/* Convert to Qwords.  */
-
-	/* NUL detection works on the principle that (X - 1) & (~X) & 0x80
-	   (=> (X - 1) & ~(X | 0x7f)) is non-zero iff a byte is zero, and
-	   can be done in parallel across the entire word.  */
-	/* The inner loop deals with two Dwords at a time.  This has a
-	   slightly higher start-up cost, but we should win quite quickly,
-	   especially on cores with a high number of issue slots per
-	   cycle, as we get much better parallelism out of the operations.  */
-
-	/* Start of critial section -- keep to one 64Byte cache line.  */
-.Lloop:
-	ldp	data1, data2, [src], #16
-.Lrealigned:
-	sub	tmp1, data1, zeroones
-	orr	tmp2, data1, #REP8_7f
-	sub	tmp3, data2, zeroones
-	orr	tmp4, data2, #REP8_7f
-	bic	has_nul1, tmp1, tmp2
-	bic	has_nul2, tmp3, tmp4
-	subs	limit_wd, limit_wd, #1
-	orr	tmp1, has_nul1, has_nul2
-	ccmp	tmp1, #0, #0, pl	/* NZCV = 0000  */
-	b.eq	.Lloop
-	/* End of critical section -- keep to one 64Byte cache line.  */
-
-	orr	tmp1, has_nul1, has_nul2
-	cbz	tmp1, .Lhit_limit	/* No null in final Qword.  */
-
-	/* We know there's a null in the final Qword.  The easiest thing
-	   to do now is work out the length of the string and return
-	   MIN (len, limit).  */
-
-	sub	len, src, srcin
-	cbz	has_nul1, .Lnul_in_data2
-#ifdef __AARCH64EB__
-	mov	data2, data1
-#endif
-	sub	len, len, #8
-	mov	has_nul2, has_nul1
-.Lnul_in_data2:
-#ifdef __AARCH64EB__
-	/* For big-endian, carry propagation (if the final byte in the
-	   string is 0x01) means we cannot use has_nul directly.  The
-	   easiest way to get the correct byte is to byte-swap the data
-	   and calculate the syndrome a second time.  */
-	rev	data2, data2
-	sub	tmp1, data2, zeroones
-	orr	tmp2, data2, #REP8_7f
-	bic	has_nul2, tmp1, tmp2
-#endif
-	sub	len, len, #8
-	rev	has_nul2, has_nul2
-	clz	pos, has_nul2
-	add	len, len, pos, lsr #3		/* Bits to bytes.  */
-	cmp	len, limit
-	csel	len, len, limit, ls		/* Return the lower value.  */
-	ret
-
-.Lmisaligned:
-	/* Deal with a partial first word.
-	   We're doing two things in parallel here;
-	   1) Calculate the number of words (but avoiding overflow if
-	      limit is near ULONG_MAX) - to do this we need to work out
-	      limit + tmp1 - 1 as a 65-bit value before shifting it;
-	   2) Load and mask the initial data words - we force the bytes
-	      before the ones we are interested in to 0xff - this ensures
-	      early bytes will not hit any zero detection.  */
-	sub	limit_wd, limit, #1
-	neg	tmp4, tmp1
-	cmp	tmp1, #8
-
-	and	tmp3, limit_wd, #15
-	lsr	limit_wd, limit_wd, #4
-	mov	tmp2, #~0
-
-	ldp	data1, data2, [src], #16
-	lsl	tmp4, tmp4, #3		/* Bytes beyond alignment -> bits.  */
-	add	tmp3, tmp3, tmp1
-
-#ifdef __AARCH64EB__
-	/* Big-endian.  Early bytes are at MSB.  */
-	lsl	tmp2, tmp2, tmp4	/* Shift (tmp1 & 63).  */
-#else
-	/* Little-endian.  Early bytes are at LSB.  */
-	lsr	tmp2, tmp2, tmp4	/* Shift (tmp1 & 63).  */
-#endif
-	add	limit_wd, limit_wd, tmp3, lsr #4
-
-	orr	data1, data1, tmp2
-	orr	data2a, data2, tmp2
-
-	csinv	data1, data1, xzr, le
-	csel	data2, data2, data2a, le
-	b	.Lrealigned
-	.size	strnlen, . - .Lstart	/* Include pre-padding in size.  */

=== removed file 'tests/test-memcmp.c'
--- tests/test-memcmp.c	2013-01-07 14:10:49 +0000
+++ tests/test-memcmp.c	1970-01-01 00:00:00 +0000
@@ -1,524 +0,0 @@
-/* Test and measure memcmp functions.
-   Copyright (C) 1999-2012 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Written by Jakub Jelinek <jakub@redhat.com>, 1999.
-   Added wmemcmp support by Liubov Dmitrieva <liubov.dmitrieva@gmail.com>, 2011.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#define TEST_MAIN
-#ifdef WIDE
-# define TEST_NAME "wmemcmp"
-#else
-# define TEST_NAME "memcmp"
-#endif
-#include "test-string.h"
-#ifdef WIDE
-# include <inttypes.h>
-# include <wchar.h>
-
-# define MEMCMP wmemcmp
-# define MEMCPY wmemcpy
-# define SIMPLE_MEMCMP simple_wmemcmp
-# define CHAR wchar_t
-# define UCHAR wchar_t
-# define CHARBYTES 4
-# define CHAR__MIN WCHAR_MIN
-# define CHAR__MAX WCHAR_MAX
-int
-simple_wmemcmp (const wchar_t *s1, const wchar_t *s2, size_t n)
-{
-  int ret = 0;
-  /* Warning!
-	wmemcmp has to use SIGNED comparison for elements.
-	memcmp has to use UNSIGNED comparison for elemnts.
-  */
-  while (n-- && (ret = *s1 < *s2 ? -1 : *s1 == *s2 ? 0 : 1) == 0) {s1++; s2++;}
-  return ret;
-}
-#else
-# include <limits.h>
-
-# define MEMCMP memcmp
-# define MEMCPY memcpy
-# define SIMPLE_MEMCMP simple_memcmp
-# define CHAR char
-# define MAX_CHAR 255
-# define UCHAR unsigned char
-# define CHARBYTES 1
-# define CHAR__MIN CHAR_MIN
-# define CHAR__MAX CHAR_MAX
-
-int
-simple_memcmp (const char *s1, const char *s2, size_t n)
-{
-  int ret = 0;
-
-  while (n-- && (ret = *(unsigned char *) s1++ - *(unsigned char *) s2++) == 0);
-  return ret;
-}
-#endif
-
-typedef int (*proto_t) (const CHAR *, const CHAR *, size_t);
-
-IMPL (SIMPLE_MEMCMP, 0)
-IMPL (MEMCMP, 1)
-
-static int
-check_result (impl_t *impl, const CHAR *s1, const CHAR *s2, size_t len,
-	      int exp_result)
-{
-  int result = CALL (impl, s1, s2, len);
-  if ((exp_result == 0 && result != 0)
-      || (exp_result < 0 && result >= 0)
-      || (exp_result > 0 && result <= 0))
-    {
-      error (0, 0, "Wrong result in function %s %d %d", impl->name,
-	     result, exp_result);
-      ret = 1;
-      return -1;
-    }
-
-  return 0;
-}
-
-static void
-do_one_test (impl_t *impl, const CHAR *s1, const CHAR *s2, size_t len,
-	     int exp_result)
-{
-  if (check_result (impl, s1, s2, len, exp_result) < 0)
-    return;
-
-  if (HP_TIMING_AVAIL)
-    {
-      hp_timing_t start __attribute ((unused));
-      hp_timing_t stop __attribute ((unused));
-      hp_timing_t best_time = ~ (hp_timing_t) 0;
-      size_t i;
-
-      for (i = 0; i < 32; ++i)
-	{
-	  HP_TIMING_NOW (start);
-	  CALL (impl, s1, s2, len);
-	  HP_TIMING_NOW (stop);
-	  HP_TIMING_BEST (best_time, start, stop);
-	}
-
-      printf ("\t%zd", (size_t) best_time);
-    }
-}
-
-static void
-do_test (size_t align1, size_t align2, size_t len, int exp_result)
-{
-  size_t i;
-  CHAR *s1, *s2;
-
-  if (len == 0)
-    return;
-
-  align1 &= 63;
-  if (align1 + (len + 1) * CHARBYTES >= page_size)
-    return;
-
-  align2 &= 63;
-  if (align2 + (len + 1) * CHARBYTES >= page_size)
-    return;
-
-  s1 = (CHAR *) (buf1 + align1);
-  s2 = (CHAR *) (buf2 + align2);
-
-  for (i = 0; i < len; i++)
-    s1[i] = s2[i] = 1 + (23 << ((CHARBYTES - 1) * 8)) * i % CHAR__MAX;
-
-  s1[len] = align1;
-  s2[len] = align2;
-  s2[len - 1] -= exp_result;
-
-  if (HP_TIMING_AVAIL)
-    printf ("Length %4zd, alignment %2zd/%2zd:", len, align1, align2);
-
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s1, s2, len, exp_result);
-
-  if (HP_TIMING_AVAIL)
-    putchar ('\n');
-}
-
-static void
-do_random_tests (void)
-{
-  size_t i, j, n, align1, align2, pos, len;
-  int result;
-  long r;
-  UCHAR *p1 =  (UCHAR *) (buf1 + page_size - 512 * CHARBYTES);
-  UCHAR *p2 =  (UCHAR *) (buf2 + page_size - 512 * CHARBYTES);
-
-  for (n = 0; n < ITERATIONS; n++)
-    {
-   align1 = random () & 31;
-      if (random () & 1)
-	align2 = random () & 31;
-      else
-	align2 = align1 + (random () & 24);
-      pos = random () & 511;
-      j = align1;
-      if (align2 > j)
-	j = align2;
-      if (pos + j >= 512)
-	pos = 511 - j - (random () & 7);
-      len = random () & 511;
-      if (len + j >= 512)
-	len = 511 - j - (random () & 7);
-      j = len + align1 + 64;
-      if (j > 512) j = 512;
-      for (i = 0; i < j; ++i)
-	p1[i] = random () & 255;
-      for (i = 0; i < j; ++i)
-	p2[i] = random () & 255;
-
-      result = 0;
-      if (pos >= len)
-	MEMCPY ((CHAR *) p2 + align2, (const CHAR *) p1 + align1, len);
-      else
-	{
-	  MEMCPY ((CHAR *) p2 + align2, (const CHAR *) p1 + align1, pos);
-	  if (p2[align2 + pos] == p1[align1 + pos])
-	    {
-	      p2[align2 + pos] = random () & 255;
-	      if (p2[align2 + pos] == p1[align1 + pos])
-		p2[align2 + pos] = p1[align1 + pos] + 3 + (random () & 127);
-	    }
-
-	  if (p1[align1 + pos] < p2[align2 + pos])
-	    result = -1;
-	  else
-	    result = 1;
-	}
-
-      FOR_EACH_IMPL (impl, 1)
-	{
-	  r = CALL (impl, (CHAR *) p1 + align1, (const CHAR *) p2 + align2,
-		    len);
-	  if ((r == 0 && result)
-	      || (r < 0 && result >= 0)
-	      || (r > 0 && result <= 0))
-	    {
-	      error (0, 0, "Iteration %zd - wrong result in function %s (%zd, %zd, %zd, %zd) %ld != %d, p1 %p p2 %p",
-		     n, impl->name, align1 * CHARBYTES & 63,  align2 * CHARBYTES & 63, len, pos, r, result, p1, p2);
-	      ret = 1;
-	    }
-	}
-    }
-}
-
-static void
-check1 (void)
-{
-  CHAR s1[116], s2[116];
-  int n, exp_result;
-
-  s1[0] = -108;
-  s2[0] = -108;
-  s1[1] = 99;
-  s2[1] = 99;
-  s1[2] = -113;
-  s2[2] = -113;
-  s1[3] = 1;
-  s2[3] = 1;
-  s1[4] = 116;
-  s2[4] = 116;
-  s1[5] = 99;
-  s2[5] = 99;
-  s1[6] = -113;
-  s2[6] = -113;
-  s1[7] = 1;
-  s2[7] = 1;
-  s1[8] = 84;
-  s2[8] = 84;
-  s1[9] = 99;
-  s2[9] = 99;
-  s1[10] = -113;
-  s2[10] = -113;
-  s1[11] = 1;
-  s2[11] = 1;
-  s1[12] = 52;
-  s2[12] = 52;
-  s1[13] = 99;
-  s2[13] = 99;
-  s1[14] = -113;
-  s2[14] = -113;
-  s1[15] = 1;
-  s2[15] = 1;
-  s1[16] = -76;
-  s2[16] = -76;
-  s1[17] = -14;
-  s2[17] = -14;
-  s1[18] = -109;
-  s2[18] = -109;
-  s1[19] = 1;
-  s2[19] = 1;
-  s1[20] = -108;
-  s2[20] = -108;
-  s1[21] = -14;
-  s2[21] = -14;
-  s1[22] = -109;
-  s2[22] = -109;
-  s1[23] = 1;
-  s2[23] = 1;
-  s1[24] = 84;
-  s2[24] = 84;
-  s1[25] = -15;
-  s2[25] = -15;
-  s1[26] = -109;
-  s2[26] = -109;
-  s1[27] = 1;
-  s2[27] = 1;
-  s1[28] = 52;
-  s2[28] = 52;
-  s1[29] = -15;
-  s2[29] = -15;
-  s1[30] = -109;
-  s2[30] = -109;
-  s1[31] = 1;
-  s2[31] = 1;
-  s1[32] = 20;
-  s2[32] = 20;
-  s1[33] = -15;
-  s2[33] = -15;
-  s1[34] = -109;
-  s2[34] = -109;
-  s1[35] = 1;
-  s2[35] = 1;
-  s1[36] = 20;
-  s2[36] = 20;
-  s1[37] = -14;
-  s2[37] = -14;
-  s1[38] = -109;
-  s2[38] = -109;
-  s1[39] = 1;
-  s2[39] = 1;
-  s1[40] = 52;
-  s2[40] = 52;
-  s1[41] = -14;
-  s2[41] = -14;
-  s1[42] = -109;
-  s2[42] = -109;
-  s1[43] = 1;
-  s2[43] = 1;
-  s1[44] = 84;
-  s2[44] = 84;
-  s1[45] = -14;
-  s2[45] = -14;
-  s1[46] = -109;
-  s2[46] = -109;
-  s1[47] = 1;
-  s2[47] = 1;
-  s1[48] = 116;
-  s2[48] = 116;
-  s1[49] = -14;
-  s2[49] = -14;
-  s1[50] = -109;
-  s2[50] = -109;
-  s1[51] = 1;
-  s2[51] = 1;
-  s1[52] = 116;
-  s2[52] = 116;
-  s1[53] = -15;
-  s2[53] = -15;
-  s1[54] = -109;
-  s2[54] = -109;
-  s1[55] = 1;
-  s2[55] = 1;
-  s1[56] = -44;
-  s2[56] = -44;
-  s1[57] = -14;
-  s2[57] = -14;
-  s1[58] = -109;
-  s2[58] = -109;
-  s1[59] = 1;
-  s2[59] = 1;
-  s1[60] = -108;
-  s2[60] = -108;
-  s1[61] = -15;
-  s2[61] = -15;
-  s1[62] = -109;
-  s2[62] = -109;
-  s1[63] = 1;
-  s2[63] = 1;
-  s1[64] = -76;
-  s2[64] = -76;
-  s1[65] = -15;
-  s2[65] = -15;
-  s1[66] = -109;
-  s2[66] = -109;
-  s1[67] = 1;
-  s2[67] = 1;
-  s1[68] = -44;
-  s2[68] = -44;
-  s1[69] = -15;
-  s2[69] = -15;
-  s1[70] = -109;
-  s2[70] = -109;
-  s1[71] = 1;
-  s2[71] = 1;
-  s1[72] = -12;
-  s2[72] = -12;
-  s1[73] = -15;
-  s2[73] = -15;
-  s1[74] = -109;
-  s2[74] = -109;
-  s1[75] = 1;
-  s2[75] = 1;
-  s1[76] = -12;
-  s2[76] = -12;
-  s1[77] = -14;
-  s2[77] = -14;
-  s1[78] = -109;
-  s2[78] = -109;
-  s1[79] = 1;
-  s2[79] = 1;
-  s1[80] = 20;
-  s2[80] = -68;
-  s1[81] = -12;
-  s2[81] = 64;
-  s1[82] = -109;
-  s2[82] = -106;
-  s1[83] = 1;
-  s2[83] = 1;
-  s1[84] = -12;
-  s2[84] = -12;
-  s1[85] = -13;
-  s2[85] = -13;
-  s1[86] = -109;
-  s2[86] = -109;
-  s1[87] = 1;
-  s2[87] = 1;
-  s1[88] = -44;
-  s2[88] = -44;
-  s1[89] = -13;
-  s2[89] = -13;
-  s1[90] = -109;
-  s2[90] = -109;
-  s1[91] = 1;
-  s2[91] = 1;
-  s1[92] = -76;
-  s2[92] = -76;
-  s1[93] = -13;
-  s2[93] = -13;
-  s1[94] = -109;
-  s2[94] = -109;
-  s1[95] = 1;
-  s2[95] = 1;
-  s1[96] = -108;
-  s2[96] = -108;
-  s1[97] = -13;
-  s2[97] = -13;
-  s1[98] = -109;
-  s2[98] = -109;
-  s1[99] = 1;
-  s2[99] = 1;
-  s1[100] = 116;
-  s2[100] = 116;
-  s1[101] = CHAR__MIN;
-  s2[101] = CHAR__MAX;
-  s1[102] = -109;
-  s2[102] = -109;
-  s1[103] = 1;
-  s2[103] = 1;
-  s1[104] = 84;
-  s2[104] = 84;
-  s1[105] = -13;
-  s2[105] = -13;
-  s1[106] = -109;
-  s2[106] = -109;
-  s1[107] = 1;
-  s2[107] = 1;
-  s1[108] = 52;
-  s2[108] = 52;
-  s1[109] = -13;
-  s2[109] = -13;
-  s1[110] = -109;
-  s2[110] = -109;
-  s1[111] = 1;
-  s2[111] = 1;
-  s1[112] = CHAR__MAX;
-  s2[112] = CHAR__MIN;
-  s1[113] = -13;
-  s2[113] = -13;
-  s1[114] = -109;
-  s2[114] = -109;
-  s1[115] = 1;
-  s2[115] = 1;
-
-  n = 116;
-  for (size_t i = 0; i < n; i++)
-    {
-      exp_result = SIMPLE_MEMCMP (s1 + i, s2 + i, n - i);
-      FOR_EACH_IMPL (impl, 0)
-	check_result (impl, s1 + i, s2 + i, n - i, exp_result);
-    }
-}
-
-int
-test_main (void)
-{
-  size_t i;
-
-  test_init ();
-
-  check1 ();
-
-  printf ("%23s", "");
-  FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
-
-  for (i = 1; i < 16; ++i)
-    {
-      do_test (i * CHARBYTES, i * CHARBYTES, i, 0);
-      do_test (i * CHARBYTES, i * CHARBYTES, i, 1);
-      do_test (i * CHARBYTES, i * CHARBYTES, i, -1);
-    }
-
-  for (i = 0; i < 16; ++i)
-    {
-      do_test (0, 0, i, 0);
-      do_test (0, 0, i, 1);
-      do_test (0, 0, i, -1);
-    }
-
-  for (i = 1; i < 10; ++i)
-    {
-      do_test (0, 0, 2 << i, 0);
-      do_test (0, 0, 2 << i, 1);
-      do_test (0, 0, 2 << i, -1);
-      do_test (0, 0, 16 << i, 0);
-      do_test ((8 - i) * CHARBYTES, (2 * i) * CHARBYTES, 16 << i, 0);
-      do_test (0, 0, 16 << i, 1);
-      do_test (0, 0, 16 << i, -1);
-    }
-
-  for (i = 1; i < 8; ++i)
-    {
-      do_test (i * CHARBYTES, 2 * (i * CHARBYTES), 8 << i, 0);
-      do_test (i * CHARBYTES, 2 * (i * CHARBYTES), 8 << i, 1);
-      do_test (i * CHARBYTES, 2 * (i * CHARBYTES), 8 << i, -1);
-    }
-
-  do_random_tests ();
-  return ret;
-}
-#include "test-skeleton.c"

=== removed file 'tests/test-memmove.c'
--- tests/test-memmove.c	2013-01-07 14:10:24 +0000
+++ tests/test-memmove.c	1970-01-01 00:00:00 +0000
@@ -1,316 +0,0 @@
-/* Test and measure memmove functions.
-   Copyright (C) 1999-2012 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Written by Jakub Jelinek <jakub@redhat.com>, 1999.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#define TEST_MAIN
-#ifdef TEST_BCOPY
-# define TEST_NAME "bcopy"
-#else
-# define TEST_NAME "memmove"
-#endif
-#include "test-string.h"
-
-char *simple_memmove (char *, const char *, size_t);
-
-#ifdef TEST_BCOPY
-typedef void (*proto_t) (const char *, char *, size_t);
-void simple_bcopy (const char *, char *, size_t);
-
-IMPL (simple_bcopy, 0)
-IMPL (bcopy, 1)
-
-void
-simple_bcopy (const char *src, char *dst, size_t n)
-{
-  simple_memmove (dst, src, n);
-}
-#else
-typedef char *(*proto_t) (char *, const char *, size_t);
-
-IMPL (simple_memmove, 0)
-IMPL (memmove, 1)
-#endif
-
-char *
-simple_memmove (char *dst, const char *src, size_t n)
-{
-  char *ret = dst;
-  if (src < dst)
-    {
-      dst += n;
-      src += n;
-      while (n--)
-	*--dst = *--src;
-    }
-  else
-    while (n--)
-      *dst++ = *src++;
-  return ret;
-}
-
-static void
-do_one_test (impl_t *impl, char *dst, char *src, const char *orig_src,
-	     size_t len)
-{
-  memcpy (src, orig_src, len);
-#ifdef TEST_BCOPY
-  CALL (impl, src, dst, len);
-#else
-  char *res;
-
-  res = CALL (impl, dst, src, len);
-  if (res != dst)
-    {
-      error (0, 0, "Wrong result in function %s %p %p", impl->name,
-	     res, dst);
-      ret = 1;
-      return;
-    }
-#endif
-
-  if (memcmp (dst, orig_src, len) != 0)
-    {
-      error (0, 0, "Wrong result in function %s dst \"%s\" src \"%s\"",
-	     impl->name, dst, src);
-      ret = 1;
-      return;
-    }
-
-  if (HP_TIMING_AVAIL)
-    {
-      hp_timing_t start __attribute ((unused));
-      hp_timing_t stop __attribute ((unused));
-      hp_timing_t best_time = ~ (hp_timing_t) 0;
-      size_t i;
-
-      for (i = 0; i < 32; ++i)
-	{
-	  HP_TIMING_NOW (start);
-#ifdef TEST_BCOPY
-	  CALL (impl, src, dst, len);
-#else
-	  CALL (impl, dst, src, len);
-#endif
-	  HP_TIMING_NOW (stop);
-	  HP_TIMING_BEST (best_time, start, stop);
-	}
-
-      printf ("\t%zd", (size_t) best_time);
-    }
-}
-
-static void
-do_test (size_t align1, size_t align2, size_t len)
-{
-  size_t i, j;
-  char *s1, *s2;
-
-  align1 &= 63;
-  if (align1 + len >= page_size)
-    return;
-
-  align2 &= 63;
-  if (align2 + len >= page_size)
-    return;
-
-  s1 = (char *) (buf1 + align1);
-  s2 = (char *) (buf2 + align2);
-
-  for (i = 0, j = 1; i < len; i++, j += 23)
-    s1[i] = j;
-
-  if (HP_TIMING_AVAIL)
-    printf ("Length %4zd, alignment %2zd/%2zd:", len, align1, align2);
-
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s2, (char *) (buf2 + align1), s1, len);
-
-  if (HP_TIMING_AVAIL)
-    putchar ('\n');
-}
-
-static void
-do_random_tests (void)
-{
-  size_t i, n, align1, align2, len, size;
-  size_t srcstart, srcend, dststart, dstend;
-  int c;
-  unsigned char *p1, *p2;
-#ifndef TEST_BCOPY
-  unsigned char *res;
-#endif
-
-  for (n = 0; n < ITERATIONS; n++)
-    {
-      if ((random () & 255) == 0)
-	size = 65536;
-      else
-	size = 512;
-      if (size > page_size)
-	size = page_size;
-      if ((random () & 3) == 0)
-	{
-	  len = random () & (size - 1);
-	  align1 = size - len - (random () & 31);
-	  align2 = size - len - (random () & 31);
-	  if (align1 > size)
-	    align1 = 0;
-	  if (align2 > size)
-	    align2 = 0;
-	}
-      else
-	{
-	  align1 = random () & (size / 2 - 1);
-	  align2 = random () & (size / 2 - 1);
-	  len = random () & (size - 1);
-	  if (align1 + len > size)
-	    align1 = size - len;
-	  if (align2 + len > size)
-	    align2 = size - len;
-	}
-
-      p1 = buf1 + page_size - size;
-      p2 = buf2 + page_size - size;
-      c = random () & 255;
-      srcend = align1 + len + 256;
-      if (srcend > size)
-	srcend = size;
-      if (align1 > 256)
-	srcstart = align1 - 256;
-      else
-	srcstart = 0;
-      for (i = srcstart; i < srcend; ++i)
-	p1[i] = random () & 255;
-      dstend = align2 + len + 256;
-      if (dstend > size)
-	dstend = size;
-      if (align2 > 256)
-	dststart = align2 - 256;
-      else
-	dststart = 0;
-
-      FOR_EACH_IMPL (impl, 1)
-	{
-	  memset (p2 + dststart, c, dstend - dststart);
-	  memcpy (p2 + srcstart, p1 + srcstart, srcend - srcstart);
-#ifdef TEST_BCOPY
-	  CALL (impl, (char *) (p2 + align1), (char *) (p2 + align2), len);
-#else
-	  res = (unsigned char *) CALL (impl,
-					(char *) (p2 + align2),
-					(char *) (p2 + align1), len);
-	  if (res != p2 + align2)
-	    {
-	      error (0, 0, "Iteration %zd - wrong result in function %s (%zd, %zd, %zd) %p != %p",
-		     n, impl->name, align1, align2, len, res, p2 + align2);
-	      ret = 1;
-	    }
-#endif
-	  if (memcmp (p1 + align1, p2 + align2, len))
-	    {
-	      error (0, 0, "Iteration %zd - different strings, %s (%zd, %zd, %zd)",
-		     n, impl->name, align1, align2, len);
-	      ret = 1;
-	    }
-	  for (i = dststart; i < dstend; ++i)
-	    {
-	      if (i >= align2 && i < align2 + len)
-		{
-		  i = align2 + len - 1;
-		  continue;
-		}
-	      if (i >= srcstart && i < srcend)
-		{
-		  i = srcend - 1;
-		  continue;
-		}
-	      if (p2[i] != c)
-		{
-		  error (0, 0, "Iteration %zd - garbage in memset area, %s (%zd, %zd, %zd)",
-			 n, impl->name, align1, align2, len);
-		  ret = 1;
-		  break;
-		}
-	    }
-
-	  if (srcstart < align2
-	      && memcmp (p2 + srcstart, p1 + srcstart,
-			 (srcend > align2 ? align2 : srcend) - srcstart))
-	    {
-	      error (0, 0, "Iteration %zd - garbage before dst, %s (%zd, %zd, %zd)",
-		     n, impl->name, align1, align2, len);
-	      ret = 1;
-	      break;
-	    }
-
-	  i = srcstart > align2 + len ? srcstart : align2 + len;
-	  if (srcend > align2 + len
-	      && memcmp (p2 + i, p1 + i, srcend - i))
-	    {
-	      error (0, 0, "Iteration %zd - garbage after dst, %s (%zd, %zd, %zd)",
-		     n, impl->name, align1, align2, len);
-	      ret = 1;
-	      break;
-	    }
-	}
-    }
-}
-
-int
-test_main (void)
-{
-  size_t i;
-
-  test_init ();
-
-  printf ("%23s", "");
-  FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
-
-  for (i = 0; i < 14; ++i)
-    {
-      do_test (0, 32, 1 << i);
-      do_test (32, 0, 1 << i);
-      do_test (0, i, 1 << i);
-      do_test (i, 0, 1 << i);
-    }
-
-  for (i = 0; i < 32; ++i)
-    {
-      do_test (0, 32, i);
-      do_test (32, 0, i);
-      do_test (0, i, i);
-      do_test (i, 0, i);
-    }
-
-  for (i = 3; i < 32; ++i)
-    {
-      if ((i & (i - 1)) == 0)
-	continue;
-      do_test (0, 32, 16 * i);
-      do_test (32, 0, 16 * i);
-      do_test (0, i, 16 * i);
-      do_test (i, 0, 16 * i);
-    }
-
-  do_random_tests ();
-  return ret;
-}
-
-#include "test-skeleton.c"

=== removed file 'tests/test-strncmp.c'
--- tests/test-strncmp.c	2013-01-07 14:11:09 +0000
+++ tests/test-strncmp.c	1970-01-01 00:00:00 +0000
@@ -1,428 +0,0 @@
-/* Test and measure strncmp functions.
-   Copyright (C) 1999-2012 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Written by Jakub Jelinek <jakub@redhat.com>, 1999.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#define TEST_MAIN
-#define TEST_NAME "strncmp"
-#include "test-string.h"
-
-typedef int (*proto_t) (const char *, const char *, size_t);
-int simple_strncmp (const char *, const char *, size_t);
-int stupid_strncmp (const char *, const char *, size_t);
-
-IMPL (stupid_strncmp, 0)
-IMPL (simple_strncmp, 0)
-IMPL (strncmp, 1)
-
-int
-simple_strncmp (const char *s1, const char *s2, size_t n)
-{
-  int ret = 0;
-
-  while (n-- && (ret = *(unsigned char *) s1 - * (unsigned char *) s2++) == 0
-	 && *s1++);
-  return ret;
-}
-
-int
-stupid_strncmp (const char *s1, const char *s2, size_t n)
-{
-  size_t ns1 = strnlen (s1, n) + 1, ns2 = strnlen (s2, n) + 1;
-  int ret = 0;
-
-  n = ns1 < n ? ns1 : n;
-  n = ns2 < n ? ns2 : n;
-  while (n-- && (ret = *(unsigned char *) s1++ - * (unsigned char *) s2++) == 0);
-  return ret;
-}
-
-static int
-check_result (impl_t *impl, const char *s1, const char *s2, size_t n,
-	     int exp_result)
-{
-  int result = CALL (impl, s1, s2, n);
-  if ((exp_result == 0 && result != 0)
-      || (exp_result < 0 && result >= 0)
-      || (exp_result > 0 && result <= 0))
-    {
-      error (0, 0, "Wrong result in function %s %d %d", impl->name,
-	     result, exp_result);
-      ret = 1;
-      return -1;
-    }
-
-  return 0;
-}
-
-static void
-do_one_test (impl_t *impl, const char *s1, const char *s2, size_t n,
-	     int exp_result)
-{
-  if (check_result (impl, s1, s2, n, exp_result) < 0)
-    return;
-
-  if (HP_TIMING_AVAIL)
-    {
-      hp_timing_t start __attribute ((unused));
-      hp_timing_t stop __attribute ((unused));
-      hp_timing_t best_time = ~ (hp_timing_t) 0;
-      size_t i;
-
-      for (i = 0; i < 32; ++i)
-	{
-	  HP_TIMING_NOW (start);
-	  CALL (impl, s1, s2, n);
-	  HP_TIMING_NOW (stop);
-	  HP_TIMING_BEST (best_time, start, stop);
-	}
-
-      printf ("\t%zd", (size_t) best_time);
-    }
-}
-
-static void
-do_test_limit (size_t align1, size_t align2, size_t len, size_t n, int max_char,
-	 int exp_result)
-{
-  size_t i, align_n;
-  char *s1, *s2;
-
-  if (n == 0)
-    {
-      s1 = (char*)(buf1 + page_size);
-      s2 = (char*)(buf2 + page_size);
-      if (HP_TIMING_AVAIL)
-	printf ("Length %4zd/%4zd:", len, n);
-
-      FOR_EACH_IMPL (impl, 0)
-	do_one_test (impl, s1, s2, n, 0);
-
-      if (HP_TIMING_AVAIL)
-	putchar ('\n');
-
-      return;
-    }
-
-  align1 &= 15;
-  align2 &= 15;
-  align_n = (page_size - n) & 15;
-
-  s1 = (char*)(buf1 + page_size - n);
-  s2 = (char*)(buf2 + page_size - n);
-
-  if (align1 < align_n)
-    s1 -= (align_n - align1);
-
-  if (align2 < align_n)
-    s2 -= (align_n - align2);
-
-  for (i = 0; i < n; i++)
-    s1[i] = s2[i] = 1 + 23 * i % max_char;
-
-  if (len < n)
-    {
-      s1[len] = 0;
-      s2[len] = 0;
-      if (exp_result < 0)
-	s2[len] = 32;
-      else if (exp_result > 0)
-	s1[len] = 64;
-    }
-
-  if (HP_TIMING_AVAIL)
-    printf ("Length %4zd/%4zd, alignment %2zd/%2zd:", len, n, align1, align2);
-
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, s1, s2, n, exp_result);
-
-  if (HP_TIMING_AVAIL)
-    putchar ('\n');
-}
-
-static void
-do_test (size_t align1, size_t align2, size_t len, size_t n, int max_char,
-	 int exp_result)
-{
-  size_t i;
-  char *s1, *s2;
-
-  if (n == 0)
-    return;
-
-  align1 &= 7;
-  if (align1 + n + 1 >= page_size)
-    return;
-
-  align2 &= 7;
-  if (align2 + n + 1 >= page_size)
-    return;
-
-  s1 = (char*)(buf1 + align1);
-  s2 = (char*)(buf2 + align2);
-
-  for (i = 0; i < n; i++)
-    s1[i] = s2[i] = 1 + 23 * i % max_char;
-
-  s1[n] = 24 + exp_result;
-  s2[n] = 23;
-  s1[len] = 0;
-  s2[len] = 0;
-  if (exp_result < 0)
-    s2[len] = 32;
-  else if (exp_result > 0)
-    s1[len] = 64;
-  if (len >= n)
-    s2[n - 1] -= exp_result;
-
-  if (HP_TIMING_AVAIL)
-    printf ("Length %4zd/%4zd, alignment %2zd/%2zd:", len, n, align1, align2);
-
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, (char*)s1, (char*)s2, n, exp_result);
-
-  if (HP_TIMING_AVAIL)
-    putchar ('\n');
-}
-
-static void
-do_page_test (size_t offset1, size_t offset2, char *s2)
-{
-  char *s1;
-  int exp_result;
-
-  if (offset1 >= page_size || offset2 >= page_size)
-    return;
-
-  s1 = (char *) (buf1 + offset1);
-  s2 += offset2;
-
-  exp_result= *s1;
-
-  FOR_EACH_IMPL (impl, 0)
-    {
-      check_result (impl, s1, s2, page_size, -exp_result);
-      check_result (impl, s2, s1, page_size, exp_result);
-    }
-}
-
-static void
-do_random_tests (void)
-{
-  size_t i, j, n, align1, align2, pos, len1, len2, size;
-  int result;
-  long r;
-  unsigned char *p1 = buf1 + page_size - 512;
-  unsigned char *p2 = buf2 + page_size - 512;
-
-  for (n = 0; n < ITERATIONS; n++)
-    {
-      align1 = random () & 31;
-      if (random () & 1)
-	align2 = random () & 31;
-      else
-	align2 = align1 + (random () & 24);
-      pos = random () & 511;
-      size = random () & 511;
-      j = align1 > align2 ? align1 : align2;
-      if (pos + j >= 511)
-	pos = 510 - j - (random () & 7);
-      len1 = random () & 511;
-      if (pos >= len1 && (random () & 1))
-	len1 = pos + (random () & 7);
-      if (len1 + j >= 512)
-	len1 = 511 - j - (random () & 7);
-      if (pos >= len1)
-	len2 = len1;
-      else
-	len2 = len1 + (len1 != 511 - j ? random () % (511 - j - len1) : 0);
-      j = (pos > len2 ? pos : len2) + align1 + 64;
-      if (j > 512)
-	j = 512;
-      for (i = 0; i < j; ++i)
-	{
-	  p1[i] = random () & 255;
-	  if (i < len1 + align1 && !p1[i])
-	    {
-	      p1[i] = random () & 255;
-	      if (!p1[i])
-		p1[i] = 1 + (random () & 127);
-	    }
-	}
-      for (i = 0; i < j; ++i)
-	{
-	  p2[i] = random () & 255;
-	  if (i < len2 + align2 && !p2[i])
-	    {
-	      p2[i] = random () & 255;
-	      if (!p2[i])
-		p2[i] = 1 + (random () & 127);
-	    }
-	}
-
-      result = 0;
-      memcpy (p2 + align2, p1 + align1, pos);
-      if (pos < len1)
-	{
-	  if (p2[align2 + pos] == p1[align1 + pos])
-	    {
-	      p2[align2 + pos] = random () & 255;
-	      if (p2[align2 + pos] == p1[align1 + pos])
-		p2[align2 + pos] = p1[align1 + pos] + 3 + (random () & 127);
-	    }
-
-	  if (pos < size)
-	    {
-	      if (p1[align1 + pos] < p2[align2 + pos])
-		result = -1;
-	      else
-		result = 1;
-	    }
-	}
-      p1[len1 + align1] = 0;
-      p2[len2 + align2] = 0;
-
-      FOR_EACH_IMPL (impl, 1)
-	{
-	  r = CALL (impl, (char*)(p1 + align1), (char*)(p2 + align2), size);
-	  /* Test whether on 64-bit architectures where ABI requires
-	     callee to promote has the promotion been done.  */
-	  asm ("" : "=g" (r) : "0" (r));
-	  if ((r == 0 && result)
-	      || (r < 0 && result >= 0)
-	      || (r > 0 && result <= 0))
-	    {
-	      error (0, 0, "Iteration %zd - wrong result in function %s (%zd, %zd, %zd, %zd, %zd, %zd) %ld != %d, p1 %p p2 %p",
-		     n, impl->name, align1, align2, len1, len2, pos, size, r, result, p1, p2);
-	      ret = 1;
-	    }
-	}
-    }
-}
-
-static void
-check1 (void)
-{
-  char *s1 = (char *)(buf1 + 0xb2c);
-  char *s2 = (char *)(buf1 + 0xfd8);
-  size_t i;
-  int exp_result;
-
-  strcpy(s1, "abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrs");
-  strcpy(s2, "abcdefghijklmnopqrstuvwxyzabcdefghijklmnopqrstuvwxyzabcdefghijkLMNOPQRSTUV");
-
-  for (i = 0; i < 80; i++)
-    {
-      exp_result = simple_strncmp (s1, s2, i);
-      FOR_EACH_IMPL (impl, 0)
-	 check_result (impl, s1, s2, i, exp_result);
-    }
-}
-
-static void
-check2 (void)
-{
-  size_t i;
-  char *s1, *s2;
-
-  s1 = (char *) buf1;
-  for (i = 0; i < page_size - 1; i++)
-    s1[i] = 23;
-  s1[i] = 0;
-
-  s2 = strdup (s1);
-
-  for (i = 0; i < 64; ++i)
-    do_page_test (3990 + i, 2635, s2);
-
-  free (s2);
-}
-
-int
-test_main (void)
-{
-  size_t i;
-
-  test_init ();
-
-  check1 ();
-  check2 ();
-
-  printf ("%23s", "");
-  FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
-
-  for (i =0; i < 16; ++i)
-    {
-      do_test (0, 0, 8, i, 127, 0);
-      do_test (0, 0, 8, i, 127, -1);
-      do_test (0, 0, 8, i, 127, 1);
-      do_test (i, i, 8, i, 127, 0);
-      do_test (i, i, 8, i, 127, 1);
-      do_test (i, i, 8, i, 127, -1);
-      do_test (i, 2 * i, 8, i, 127, 0);
-      do_test (2 * i, i, 8, i, 127, 1);
-      do_test (i, 3 * i, 8, i, 127, -1);
-      do_test (0, 0, 8, i, 255, 0);
-      do_test (0, 0, 8, i, 255, -1);
-      do_test (0, 0, 8, i, 255, 1);
-      do_test (i, i, 8, i, 255, 0);
-      do_test (i, i, 8, i, 255, 1);
-      do_test (i, i, 8, i, 255, -1);
-      do_test (i, 2 * i, 8, i, 255, 0);
-      do_test (2 * i, i, 8, i, 255, 1);
-      do_test (i, 3 * i, 8, i, 255, -1);
-    }
-
-  for (i = 1; i < 8; ++i)
-    {
-      do_test (0, 0, 8 << i, 16 << i, 127, 0);
-      do_test (0, 0, 8 << i, 16 << i, 127, 1);
-      do_test (0, 0, 8 << i, 16 << i, 127, -1);
-      do_test (0, 0, 8 << i, 16 << i, 255, 0);
-      do_test (0, 0, 8 << i, 16 << i, 255, 1);
-      do_test (0, 0, 8 << i, 16 << i, 255, -1);
-      do_test (8 - i, 2 * i, 8 << i, 16 << i, 127, 0);
-      do_test (8 - i, 2 * i, 8 << i, 16 << i, 127, 1);
-      do_test (2 * i, i, 8 << i, 16 << i, 255, 0);
-      do_test (2 * i, i, 8 << i, 16 << i, 255, 1);
-    }
-
-  do_test_limit (0, 0, 0, 0, 127, 0);
-  do_test_limit (4, 0, 21, 20, 127, 0);
-  do_test_limit (0, 4, 21, 20, 127, 0);
-  do_test_limit (8, 0, 25, 24, 127, 0);
-  do_test_limit (0, 8, 25, 24, 127, 0);
-
-  for (i = 0; i < 8; ++i)
-    {
-      do_test_limit (0, 0, 17 - i, 16 - i, 127, 0);
-      do_test_limit (0, 0, 17 - i, 16 - i, 255, 0);
-      do_test_limit (0, 0, 15 - i, 16 - i, 127, 0);
-      do_test_limit (0, 0, 15 - i, 16 - i, 127, 1);
-      do_test_limit (0, 0, 15 - i, 16 - i, 127, -1);
-      do_test_limit (0, 0, 15 - i, 16 - i, 255, 0);
-      do_test_limit (0, 0, 15 - i, 16 - i, 255, 1);
-      do_test_limit (0, 0, 15 - i, 16 - i, 255, -1);
-    }
-
-  do_random_tests ();
-  return ret;
-}
-
-#include "test-skeleton.c"

=== removed file 'tests/test-strnlen.c'
--- tests/test-strnlen.c	2013-01-07 15:56:21 +0000
+++ tests/test-strnlen.c	1970-01-01 00:00:00 +0000
@@ -1,199 +0,0 @@
-/* Test and measure strlen functions.
-   Copyright (C) 1999-2012 Free Software Foundation, Inc.
-   This file is part of the GNU C Library.
-   Written by Jakub Jelinek <jakub@redhat.com>, 1999.
-
-   The GNU C Library is free software; you can redistribute it and/or
-   modify it under the terms of the GNU Lesser General Public
-   License as published by the Free Software Foundation; either
-   version 2.1 of the License, or (at your option) any later version.
-
-   The GNU C Library is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
-   Lesser General Public License for more details.
-
-   You should have received a copy of the GNU Lesser General Public
-   License along with the GNU C Library; if not, see
-   <http://www.gnu.org/licenses/>.  */
-
-#define TEST_MAIN
-#define TEST_NAME "strnlen"
-#include "test-string.h"
-
-#define MIN(a,b) ((a) < (b) ? (a) : (b))
-
-typedef size_t (*proto_t) (const char *, size_t);
-size_t simple_strnlen (const char *, size_t);
-
-IMPL (simple_strnlen, 0)
-IMPL (strnlen, 1)
-
-size_t
-simple_strnlen (const char *s, size_t maxlen)
-{
-  size_t i;
-
-  for (i = 0; i < maxlen && s[i]; ++i);
-  return i;
-}
-
-static void
-do_one_test (impl_t *impl, const char *s, size_t maxlen, size_t exp_len)
-{
-  size_t len = CALL (impl, s, maxlen);
-  if (len != exp_len)
-    {
-      error (0, 0, "Wrong result in function %s %zd %zd", impl->name,
-	     len, exp_len);
-      ret = 1;
-      return;
-    }
-
-  if (HP_TIMING_AVAIL)
-    {
-      hp_timing_t start __attribute ((unused));
-      hp_timing_t stop __attribute ((unused));
-      hp_timing_t best_time = ~ (hp_timing_t) 0;
-      size_t i;
-
-      for (i = 0; i < 32; ++i)
-	{
-	  HP_TIMING_NOW (start);
-	  CALL (impl, s, maxlen);
-	  HP_TIMING_NOW (stop);
-	  HP_TIMING_BEST (best_time, start, stop);
-	}
-
-      printf ("\t%zd", (size_t) best_time);
-    }
-}
-
-static void
-do_test (size_t align, size_t len, size_t maxlen, int max_char)
-{
-  size_t i;
-
-  align &= 7;
-  if (align + len >= page_size)
-    return;
-
-  for (i = 0; i < len; ++i)
-    buf1[align + i] = 1 + 7 * i % max_char;
-  buf1[align + len] = 0;
-
-  if (HP_TIMING_AVAIL)
-    printf ("Length %4zd, alignment %2zd:", len, align);
-
-  FOR_EACH_IMPL (impl, 0)
-    do_one_test (impl, (char *) (buf1 + align), maxlen, MIN (len, maxlen));
-
-  if (HP_TIMING_AVAIL)
-    putchar ('\n');
-}
-
-static void
-do_random_tests (void)
-{
-  size_t i, j, n, align, len;
-  unsigned char *p = buf1 + page_size - 512;
-
-  for (n = 0; n < ITERATIONS; n++)
-    {
-      align = random () & 15;
-      len = random () & 511;
-      if (len + align > 510)
-	len = 511 - align - (random () & 7);
-      j = len + align + 64;
-      if (j > 512)
-	j = 512;
-
-      for (i = 0; i < j; i++)
-	{
-	  if (i == len + align)
-	    p[i] = 0;
-	  else
-	    {
-	      p[i] = random () & 255;
-	      if (i >= align && i < len + align && !p[i])
-		p[i] = (random () & 127) + 1;
-	    }
-	}
-
-      FOR_EACH_IMPL (impl, 1)
-	{
-	  if (len > 0
-	      && CALL (impl, (char *) (p + align), len - 1) != len - 1)
-	    {
-	      error (0, 0, "Iteration %zd (limited) - wrong result in function %s (%zd) %zd != %zd, p %p",
-		     n, impl->name, align,
-		     CALL (impl, (char *) (p + align), len - 1), len - 1, p);
-	      ret = 1;
-	    }
-	  if (CALL (impl, (char *) (p + align), len) != len)
-	    {
-	      error (0, 0, "Iteration %zd (exact) - wrong result in function %s (%zd) %zd != %zd, p %p",
-		     n, impl->name, align,
-		     CALL (impl, (char *) (p + align), len), len, p);
-	      ret = 1;
-	    }
-	  if (CALL (impl, (char *) (p + align), len + 1) != len)
-	    {
-	      error (0, 0, "Iteration %zd (long) - wrong result in function %s (%zd) %zd != %zd, p %p",
-		     n, impl->name, align,
-		     CALL (impl, (char *) (p + align), len + 1), len, p);
-	      ret = 1;
-	    }
-	}
-    }
-}
-
-int
-test_main (void)
-{
-  size_t i;
-
-  test_init ();
-
-  printf ("%20s", "");
-  FOR_EACH_IMPL (impl, 0)
-    printf ("\t%s", impl->name);
-  putchar ('\n');
-
-  for (i = 1; i < 8; ++i)
-    {
-      do_test (0, i, i - 1, 127);
-      do_test (0, i, i, 127);
-      do_test (0, i, i + 1, 127);
-    }
-
-  for (i = 1; i < 8; ++i)
-    {
-      do_test (i, i, i - 1, 127);
-      do_test (i, i, i, 127);
-      do_test (i, i, i + 1, 127);
-    }
-
-  for (i = 2; i <= 10; ++i)
-    {
-      do_test (0, 1 << i, 5000, 127);
-      do_test (1, 1 << i, 5000, 127);
-    }
-
-  for (i = 1; i < 8; ++i)
-    do_test (0, i, 5000, 255);
-
-  for (i = 1; i < 8; ++i)
-    do_test (i, i, 5000, 255);
-
-  for (i = 2; i <= 10; ++i)
-    {
-      do_test (0, 1 << i, 5000, 255);
-      do_test (1, 1 << i, 5000, 255);
-    }
-
-  do_random_tests ();
-  return ret;
-}
-
-#include "test-skeleton.c"

